{******************************************************************************}
{*                                                                            *}
{*  Copyright (c) 2002, NVIDIA Corporation.                                   *}
{*                                                                            *}
{*  Files:    cg_deprecated_api.h, cg_datatypes.h, cg_errors.h,               *}
{*            cg_profiles.h, cgGL_profiles.h, cg_bindlocations.h              *}
{*  Content:  NVIDIA Cg Deprecated API core include files                     *}
{*                                                                            *}
{*  NVIDIA "Cg" Release 1.1 ObjectPascal adaptation by Alexey Barkovoy        *}
{*  E-Mail: clootie@reactor.ru                                                *}
{*                                                                            *}
{*  Modified: 21-Mar-2003                                                     *}
{*                                                                            *}
{*  Latest version can be downloaded from:                                    *}
{*     http://clootie.narod.ru                                                *}
{*                                                                            *}
{******************************************************************************}
{*                                                                            *}
{******************************************************************************}
{                                                                              }
{ Obtained through: Joint Endeavour of Delphi Innovators (Project JEDI)        }
{                                                                              }
{ The contents of this file are used with permission, subject to the Mozilla   }
{ Public License Version 1.1 (the "License"); you may not use this file except }
{ in compliance with the License. You may obtain a copy of the License at      }
{ http://www.mozilla.org/MPL/MPL-1.1.html                                      }
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS" basis,   }
{ WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for }
{ the specific language governing rights and limitations under the License.    }
{                                                                              }
{ Alternatively, the contents of this file may be used under the terms of the  }
{ GNU Lesser General Public License (the  "LGPL License"), in which case the   }
{ provisions of the LGPL License are applicable instead of those above.        }
{ If you wish to allow use of your version of this file only under the terms   }
{ of the LGPL License and not to allow others to use your version of this file }
{ under the MPL, indicate your decision by deleting  the provisions above and  }
{ replace  them with the notice and other provisions required by the LGPL      }
{ License.  If you do not delete the provisions above, a recipient may use     }
{ your version of this file under either the MPL or the LGPL License.          }
{                                                                              }
{ For more information about the LGPL: http://www.gnu.org/copyleft/lesser.html }
{                                                                              }
{******************************************************************************}

(*
 *
 * Copyright (c) 2002, NVIDIA Corporation.
 *
 *
 *
 * NVIDIA Corporation("NVIDIA") supplies this software to you in consideration
 * of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this NVIDIA software constitutes
 * acceptance of these terms.  If you do not agree with these terms, please do
 * not use, install, modify or redistribute this NVIDIA software.
 * 
 *  
 * 
 * In consideration of your agreement to abide by the following terms, and 
 * subject to these terms, NVIDIA grants you a personal, non-exclusive license,
 * under NVIDIAs copyrights in this original NVIDIA software (the "NVIDIA 
 * Software"), to use, reproduce, modify and redistribute the NVIDIA 
 * Software, with or without modifications, in source and/or binary forms; 
 * provided that if you redistribute the NVIDIA Software, you must retain the 
 * copyright notice of NVIDIA, this notice and the following text and
 * disclaimers in all such redistributions of the NVIDIA Software. Neither the
 * name, trademarks, service marks nor logos of NVIDIA Corporation may be used
 * to endorse or promote products derived from the NVIDIA Software without
 * specific prior written permission from NVIDIA.  Except as expressly stated
 * in this notice, no other rights or licenses express or implied, are granted
 * by NVIDIA herein, including but not limited to any patent rights that may be
 * infringed by your derivative works or by other works in which the NVIDIA
 * Software may be incorporated. No hardware is licensed hereunder.
 *
 *
 *
 * THE NVIDIA SOFTWARE IS BEING PROVIDED ON AN "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
 * WITHOUT LIMITATION, WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR ITS USE AND OPERATION 
 * EITHER ALONE OR IN COMBINATION WITH OTHER PRODUCTS.
 * 
 *  
 * 
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
 * EXEMPLARY, CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOST 
 * PROFITS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) OR ARISING IN ANY WAY OUT OF THE USE, 
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE NVIDIA SOFTWARE, 
 * HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING 
 * NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF NVIDIA HAS BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *)

//////////////////////////////////////////////////////////////////////////////
// HISTORY:
// 21-Mar-03 - Alexey Barkovoy:
//   - Updated to Release 1.1 of Cg toolkit (published 04-Mar-2003)
// 11-Jan-03 - Alexey Barkovoy:
//   - Updated to Release 1.0 of Cg toolkit (published 20-Dec-2002)
// 27-Sep-02 - Alexey Barkovoy:
//   - Updated to Beta 2.1 of Cg toolkit (compiler version 1.5.0001)
// 26-Aug-02 - Alexey Barkovoy:
//   - Updated to Beta2 of Cg toolkit (compiler version 1.5)
// 01-Jul-02 - Alexey Barkovoy:
//   - Changed to INC file
// 18-Jun-02 - Alexey Barkovoy:
//   - TcgProfileType corrected

{$Include JEDI.inc}
{$MINENUMSIZE 4}

(*************************************************************************)
(*** CG Run-Time Library API                                          ***)
(*************************************************************************)

(*************************************************************************)
(*** Data types and structures                                         ***)
(*************************************************************************)

type
  (*
   * The following define error codes returned by various cg
   * API functions.
   *
   *   CG_ERROR_MACRO(code, enum_name, message)
   *
   *     code      : The integer error code associated with the error.
   *     enum_name : The name of enumerant of the error code.
   *                  (Note : the prefix "cg" will be added to the name).
   *     new_enum_name : The name of enumerant of the error code in the new API.
   *     message   : A description string associated with the error.
   *
   *)
  TcgError = DWORD;
  cgError = TcgError;
  {$NODEFINE cgError}
  {$NODEFINE TcgError}
  {$HPPEMIT 'typedef cgError TcgError;'}

const
  //# define CG_ERROR_MACRO(code, enum_name, new_enum_name, message) \
  //   cg##enum_name = code,
  cgNoError                     = 0;  // "No error has occurred."
  {$EXTERNALSYM cgNoError}
  cgCompileError                = 1;  // "The compile returned an error."
  {$EXTERNALSYM cgCompileError}
  cgInvalidParameterError       = 2;  // "The parameter used is invalid."
  {$EXTERNALSYM cgInvalidParameterError}
  cgInvalidProfileError         = 3;  // "The profile is not supported."
  {$EXTERNALSYM cgInvalidProfileError}
  cgProgramLoadError            = 4;  // "The program did could not load."
  {$EXTERNALSYM cgProgramLoadError}
  cgProgramBindError            = 5;  // "The program could not bind."
  {$EXTERNALSYM cgProgramBindError}
  cgProgramNotLoadedError       = 6;  // "The program must be loaded before this operation may be used."
  {$EXTERNALSYM cgProgramNotLoadedError}
  cgUnsupportedGLExtensionError = 7;  // "An unsupported GL extension was required to perform this operation."
  {$EXTERNALSYM cgUnsupportedGLExtensionError}
  cgInvalidValueTypeError       = 8;  // "An unknown value type was assigned to a parameter."
  {$EXTERNALSYM cgInvalidValueTypeError}
  cgNotMatrixParamError         = 9;  // "The parameter is not of matrix type."
  {$EXTERNALSYM cgNotMatrixParamError}
  cgInvalidEnumerantError       = 10; // "The enumerant parameter has an invalid value."
  {$EXTERNALSYM cgInvalidEnumerantError}
  cgNot4x4MatrixError           = 11; // "The parameter must be a 4x4 matrix type."
  {$EXTERNALSYM cgNot4x4MatrixError}
  cgFileReadError               = 12; // "The file could not be read."
  {$EXTERNALSYM cgFileReadError}
  cgFileWriteError              = 13; // "The file could not be written."
  {$EXTERNALSYM cgFileWriteError}
  cgNVParseError                = 14; // "nvparse could not successfully parse the output from the Cg compiler backend."
  {$EXTERNALSYM cgNVParseError}
  cgMemoryAllocError            = 15; // "Memory allocation failed."
  {$EXTERNALSYM cgMemoryAllocError}
  cgInvalidContextHandleError   = 16; // "Invalid context handle."
  {$EXTERNALSYM cgInvalidContextHandleError}
  cgInvalidProgramHandleError   = 17; // "Invalid program handle."
  {$EXTERNALSYM cgInvalidProgramHandleError}
  cgInvalidParamHandleError     = 18; // "Invalid parameter handle."
  {$EXTERNALSYM cgInvalidParamHandleError}
  cgUnknownProfileError         = 19; // "The specified profile is unknown."
  {$EXTERNALSYM cgUnknownProfileError}
  cgVarArgError                 = 20; // "The variable arguments were specified incorrectly."
  {$EXTERNALSYM cgVarArgError}
  cgInvalidDimensionError       = 21; // "The dimension value is invalid."
  {$EXTERNALSYM cgInvalidDimensionError}
  cgArrayParamError             = 22; // "The parameter must be an array."
  {$EXTERNALSYM cgArrayParamError}
  cgOutOfArrayBoundsError       = 23; // "Index into the array is out of bounds."
  {$EXTERNALSYM cgOutOfArrayBoundsError}

type
  PcgContext = ^TcgContext;
  TcgContext = packed record
    (* Opaque structure *)
    Data: Pointer;
  end;
  cgContext = TcgContext;
  {$NODEFINE cgContext}
  {$NODEFINE TcgContext}
  {$HPPEMIT 'typedef cgContext TcgContext;'}

  PcgProgramIter = ^TcgProgramIter;
  TcgProgramIter = packed record
    (* Opaque structure *)
    Data: Pointer;
  end;
  cgProgramIter = TcgProgramIter;
  {$NODEFINE cgProgramIter}
  {$NODEFINE TcgProgramIter}
  {$HPPEMIT 'typedef cgProgramIter TcgProgramIter;'}

  PcgBindIter = ^TcgBindIter;
  TcgBindIter = packed record
    (* Opaque structure *)
    Data: Pointer;
  end;
  cgBindIter = TcgBindIter;
  {$NODEFINE cgBindIter}
  {$NODEFINE TcgBindIter}
  {$HPPEMIT 'typedef cgBindIter TcgBindIter;'}


  (*
   * The following define the supported CG basic data types.
   *
   *   CG_DATATYPE_MACRO(name, compiler_name, nrows, ncols)
   *
   *     name          : The name of the data type.
   *     compiler_name : The name of the data type within the compiler syntax.
   *     enum_name     : The C enumerant.
   *     nrows         : Number of rows for matrix types.  Should be 0 other-wise.
   *     ncols         : Number of columns for matrix types.  Should be 0
   *                     other-wise.
   *
   *)
{$IFDEF COMPILER6_UP}
  TcgValueType = (
  {$IFDEF BCB}
    cgDummyValueType
  {$ELSE}
    cgUnknownValueType,
    cgTypeStartEnum = 1024,
    //# define CG_DATATYPE_MACRO(name, compiler_name, enum_name, ncols, nrows) \
    //  cg##name##ValueType,
    cgHalfValueType,      // CG_DATATYPE_MACRO(Half,half,CG_HALF,0,0)
    cgHalf2ValueType,     // CG_DATATYPE_MACRO(Half2,half2,CG_HALF2,0,0)
    cgHalf3ValueType,     // CG_DATATYPE_MACRO(Half3,half3,CG_HALF3,0,0)
    cgHalf4ValueType,     // CG_DATATYPE_MACRO(Half4,half4,CG_HALF4,0,0)
    cgHalf1x1ValueType,   // CG_DATATYPE_MACRO(Half1x1,half1x1,CG_HALF1x1,1,1)
    cgHalf1x2ValueType,   // CG_DATATYPE_MACRO(Half1x2,half1x2,CG_HALF1x2,1,2)
    cgHalf1x3ValueType,   // CG_DATATYPE_MACRO(Half1x3,half1x3,CG_HALF1x3,1,3)
    cgHalf1x4ValueType,   // CG_DATATYPE_MACRO(Half1x4,half1x4,CG_HALF1x4,1,4)
    cgHalf2x1ValueType,   // CG_DATATYPE_MACRO(Half2x1,half2x1,CG_HALF2x1,2,1)
    cgHalf2x2ValueType,   // CG_DATATYPE_MACRO(Half2x2,half2x2,CG_HALF2x2,2,2)
    cgHalf2x3ValueType,   // CG_DATATYPE_MACRO(Half2x3,half2x3,CG_HALF2x3,2,3)
    cgHalf2x4ValueType,   // CG_DATATYPE_MACRO(Half2x4,half2x4,CG_HALF2x4,2,4)
    cgHalf3x1ValueType,   // CG_DATATYPE_MACRO(Half3x1,half3x1,CG_HALF3x1,3,1)
    cgHalf3x2ValueType,   // CG_DATATYPE_MACRO(Half3x2,half3x2,CG_HALF3x2,3,2)
    cgHalf3x3ValueType,   // CG_DATATYPE_MACRO(Half3x3,half3x3,CG_HALF3x3,3,3)
    cgHalf3x4ValueType,   // CG_DATATYPE_MACRO(Half3x4,half3x4,CG_HALF3x4,3,4)
    cgHalf4x1ValueType,   // CG_DATATYPE_MACRO(Half4x1,half4x1,CG_HALF4x1,4,1)
    cgHalf4x2ValueType,   // CG_DATATYPE_MACRO(Half4x2,half4x2,CG_HALF4x2,4,2)
    cgHalf4x3ValueType,   // CG_DATATYPE_MACRO(Half4x3,half4x3,CG_HALF4x3,4,3)
    cgHalf4x4ValueType,   // CG_DATATYPE_MACRO(Half4x4,half4x4,CG_HALF4x4,4,4)
    cgFloatValueType,     // CG_DATATYPE_MACRO(Float,float,CG_FLOAT,0,0)
    cgFloat2ValueType,    // CG_DATATYPE_MACRO(Float2,float2,CG_FLOAT2,0,0)
    cgFloat3ValueType,    // CG_DATATYPE_MACRO(Float3,float3,CG_FLOAT3,0,0)
    cgFloat4ValueType,    // CG_DATATYPE_MACRO(Float4,float4,CG_FLOAT4,0,0)
    cgFloat1x1ValueType,  // CG_DATATYPE_MACRO(Float1x1,float1x1,CG_FLOAT1x1,1,1)
    cgFloat1x2ValueType,  // CG_DATATYPE_MACRO(Float1x2,float1x2,CG_FLOAT1x2,1,2)
    cgFloat1x3ValueType,  // CG_DATATYPE_MACRO(Float1x3,float1x3,CG_FLOAT1x3,1,3)
    cgFloat1x4ValueType,  // CG_DATATYPE_MACRO(Float1x4,float1x4,CG_FLOAT1x4,1,4)
    cgFloat2x1ValueType,  // CG_DATATYPE_MACRO(Float2x1,float2x1,CG_FLOAT2x1,2,1)
    cgFloat2x2ValueType,  // CG_DATATYPE_MACRO(Float2x2,float2x2,CG_FLOAT2x2,2,2)
    cgFloat2x3ValueType,  // CG_DATATYPE_MACRO(Float2x3,float2x3,CG_FLOAT2x3,2,3)
    cgFloat2x4ValueType,  // CG_DATATYPE_MACRO(Float2x4,float2x4,CG_FLOAT2x4,2,4)
    cgFloat3x1ValueType,  // CG_DATATYPE_MACRO(Float3x1,float3x1,CG_FLOAT3x1,3,1)
    cgFloat3x2ValueType,  // CG_DATATYPE_MACRO(Float3x2,float3x2,CG_FLOAT3x2,3,2)
    cgFloat3x3ValueType,  // CG_DATATYPE_MACRO(Float3x3,float3x3,CG_FLOAT3x3,3,3)
    cgFloat3x4ValueType,  // CG_DATATYPE_MACRO(Float3x4,float3x4,CG_FLOAT3x4,3,4)
    cgFloat4x1ValueType,  // CG_DATATYPE_MACRO(Float4x1,float4x1,CG_FLOAT4x1,4,1)
    cgFloat4x2ValueType,  // CG_DATATYPE_MACRO(Float4x2,float4x2,CG_FLOAT4x2,4,2)
    cgFloat4x3ValueType,  // CG_DATATYPE_MACRO(Float4x3,float4x3,CG_FLOAT4x3,4,3)
    cgFloat4x4ValueType,  // CG_DATATYPE_MACRO(Float4x4,float4x4,CG_FLOAT4x4,4,4)
    cgSampler1DValueType, // CG_DATATYPE_MACRO(Sampler1D,sampler1D,CG_SAMPLER1D,0,0)
    cgSampler2DValueType, // CG_DATATYPE_MACRO(Sampler2D,sampler2D,CG_SAMPLER2D,0,0)
    cgSampler3DValueType, // CG_DATATYPE_MACRO(Sampler3D,sampler3D,CG_SAMPLER3D,0,0)
    cgSamplerRECTValueType, // CG_DATATYPE_MACRO(SamplerRECT,samplerRECT,CG_SAMPLERRECT,0,0)
    cgSamplerCUBEValueType, // CG_DATATYPE_MACRO(SamplerCUBE,samplerCUBE,CG_SAMPLERCUBE,0,0)
    cgFixedValueType,     // CG_DATATYPE_MACRO(Fixed,fixed,CG_FIXED,0,0)
    cgFixed2ValueType,    // CCG_DATATYPE_MACRO(Fixed2,fixed2,CG_FIXED2,0,0)
    cgFixed3ValueType,    // CCG_DATATYPE_MACRO(Fixed3,fixed3,CG_FIXED3,0,0)
    cgFixed4ValueType,    // CCG_DATATYPE_MACRO(Fixed4,fixed4,CG_FIXED4,0,0)
    cgFixed1x1ValueType,  // CCG_DATATYPE_MACRO(Fixed1x1,fixed1x1,CG_FIXED1x1,1,1)
    cgFixed1x2ValueType,  // CCG_DATATYPE_MACRO(Fixed1x2,fixed1x2,CG_FIXED1x2,1,2)
    cgFixed1x3ValueType,  // CCG_DATATYPE_MACRO(Fixed1x3,fixed1x3,CG_FIXED1x3,1,3)
    cgFixed1x4ValueType,  // CCG_DATATYPE_MACRO(Fixed1x4,fixed1x4,CG_FIXED1x4,1,4)
    cgFixed2x1ValueType,  // CCG_DATATYPE_MACRO(Fixed2x1,fixed2x1,CG_FIXED2x1,2,1)
    cgFixed2x2ValueType,  // CCG_DATATYPE_MACRO(Fixed2x2,fixed2x2,CG_FIXED2x2,2,2)
    cgFixed2x3ValueType,  // CCG_DATATYPE_MACRO(Fixed2x3,fixed2x3,CG_FIXED2x3,2,3)
    cgFixed2x4ValueType,  // CCG_DATATYPE_MACRO(Fixed2x4,fixed2x4,CG_FIXED2x4,2,4)
    cgFixed3x1ValueType,  // CCG_DATATYPE_MACRO(Fixed3x1,fixed3x1,CG_FIXED3x1,3,1)
    cgFixed3x2ValueType,  // CCG_DATATYPE_MACRO(Fixed3x2,fixed3x2,CG_FIXED3x2,3,2)
    cgFixed3x3ValueType,  // CCG_DATATYPE_MACRO(Fixed3x3,fixed3x3,CG_FIXED3x3,3,3)
    cgFixed3x4ValueType,  // CCG_DATATYPE_MACRO(Fixed3x4,fixed3x4,CG_FIXED3x4,3,4)
    cgFixed4x1ValueType,  // CCG_DATATYPE_MACRO(Fixed4x1,fixed4x1,CG_FIXED4x1,4,1)
    cgFixed4x2ValueType,  // CCG_DATATYPE_MACRO(Fixed4x2,fixed4x2,CG_FIXED4x2,4,2)
    cgFixed4x3ValueType,  // CCG_DATATYPE_MACRO(Fixed4x3,fixed4x3,CG_FIXED4x3,4,3)
    cgFixed4x4ValueType,  // CCG_DATATYPE_MACRO(Fixed4x4,fixed4x4,CG_FIXED4x4,4,4)
    cgHalf1ValueType,     // CCG_DATATYPE_MACRO(Half1,half1,CG_HALF1,0,0)
    cgFloat1ValueType,    // CCG_DATATYPE_MACRO(Float1,float1,CG_FLOAT1,0,0)
    cgFixed1ValueType     // CCG_DATATYPE_MACRO(Fixed1,fixed1,CG_FIXED1,0,0)
  {$ENDIF}
  );
{$ELSE}
const
  cgUnknownValueType = 0;
  {$EXTERNALSYM cgUnknownValueType}
  cgTypeStartEnum = 1024;
  {$EXTERNALSYM cgTypeStartEnum}
  //# define CG_DATATYPE_MACRO(name, compiler_name, enum_name, ncols, nrows) \
  //  cg##name##ValueType,
  cgHalfValueType = 1025;      // CG_DATATYPE_MACRO(Half,half,CG_HALF,0,0)
  {$EXTERNALSYM cgHalfValueType}
  cgHalf2ValueType = 1026;     // CG_DATATYPE_MACRO(Half2,half2,CG_HALF2,0,0)
  {$EXTERNALSYM cgHalf2ValueType}
  cgHalf3ValueType = 1027;     // CG_DATATYPE_MACRO(Half3,half3,CG_HALF3,0,0)
  {$EXTERNALSYM cgHalf3ValueType}
  cgHalf4ValueType = 1028;     // CG_DATATYPE_MACRO(Half4,half4,CG_HALF4,0,0)
  {$EXTERNALSYM cgHalf4ValueType}
  cgHalf1x1ValueType = 1029;   // CG_DATATYPE_MACRO(Half1x1,half1x1,CG_HALF1x1,1,1)
  {$EXTERNALSYM cgHalf1x1ValueType}
  cgHalf1x2ValueType = 1030;   // CG_DATATYPE_MACRO(Half1x2,half1x2,CG_HALF1x2,1,2)
  {$EXTERNALSYM cgHalf1x2ValueType}
  cgHalf1x3ValueType = 1031;   // CG_DATATYPE_MACRO(Half1x3,half1x3,CG_HALF1x3,1,3)
  {$EXTERNALSYM cgHalf1x3ValueType}
  cgHalf1x4ValueType = 1032;   // CG_DATATYPE_MACRO(Half1x4,half1x4,CG_HALF1x4,1,4)
  {$EXTERNALSYM cgHalf1x4ValueType}
  cgHalf2x1ValueType = 1033;   // CG_DATATYPE_MACRO(Half2x1,half2x1,CG_HALF2x1,2,1)
  {$EXTERNALSYM cgHalf2x1ValueType}
  cgHalf2x2ValueType = 1034;   // CG_DATATYPE_MACRO(Half2x2,half2x2,CG_HALF2x2,2,2)
  {$EXTERNALSYM cgHalf2x2ValueType}
  cgHalf2x3ValueType = 1035;   // CG_DATATYPE_MACRO(Half2x3,half2x3,CG_HALF2x3,2,3)
  {$EXTERNALSYM cgHalf2x3ValueType}
  cgHalf2x4ValueType = 1036;   // CG_DATATYPE_MACRO(Half2x4,half2x4,CG_HALF2x4,2,4)
  {$EXTERNALSYM cgHalf2x4ValueType}
  cgHalf3x1ValueType = 1037;   // CG_DATATYPE_MACRO(Half3x1,half3x1,CG_HALF3x1,3,1)
  {$EXTERNALSYM cgHalf3x1ValueType}
  cgHalf3x2ValueType = 1038;   // CG_DATATYPE_MACRO(Half3x2,half3x2,CG_HALF3x2,3,2)
  {$EXTERNALSYM cgHalf3x2ValueType}
  cgHalf3x3ValueType = 1039;   // CG_DATATYPE_MACRO(Half3x3,half3x3,CG_HALF3x3,3,3)
  {$EXTERNALSYM cgHalf3x3ValueType}
  cgHalf3x4ValueType = 1040;   // CG_DATATYPE_MACRO(Half3x4,half3x4,CG_HALF3x4,3,4)
  {$EXTERNALSYM cgHalf3x4ValueType}
  cgHalf4x1ValueType = 1041;   // CG_DATATYPE_MACRO(Half4x1,half4x1,CG_HALF4x1,4,1)
  {$EXTERNALSYM cgHalf4x1ValueType}
  cgHalf4x2ValueType = 1042;   // CG_DATATYPE_MACRO(Half4x2,half4x2,CG_HALF4x2,4,2)
  {$EXTERNALSYM cgHalf4x2ValueType}
  cgHalf4x3ValueType = 1043;   // CG_DATATYPE_MACRO(Half4x3,half4x3,CG_HALF4x3,4,3)
  {$EXTERNALSYM cgHalf4x3ValueType}
  cgHalf4x4ValueType = 1044;   // CG_DATATYPE_MACRO(Half4x4,half4x4,CG_HALF4x4,4,4)
  {$EXTERNALSYM cgHalf4x4ValueType}
  cgFloatValueType = 1045;     // CG_DATATYPE_MACRO(Float,float,CG_FLOAT,0,0)
  {$EXTERNALSYM cgFloatValueType}
  cgFloat2ValueType = 1046;    // CG_DATATYPE_MACRO(Float2,float2,CG_FLOAT2,0,0)
  {$EXTERNALSYM cgFloat2ValueType}
  cgFloat3ValueType = 1047;    // CG_DATATYPE_MACRO(Float3,float3,CG_FLOAT3,0,0)
  {$EXTERNALSYM cgFloat3ValueType}
  cgFloat4ValueType = 1048;    // CG_DATATYPE_MACRO(Float4,float4,CG_FLOAT4,0,0)
  {$EXTERNALSYM cgFloat4ValueType}
  cgFloat1x1ValueType = 1049;  // CG_DATATYPE_MACRO(Float1x1,float1x1,CG_FLOAT1x1,1,1)
  {$EXTERNALSYM cgFloat1x1ValueType}
  cgFloat1x2ValueType = 1050;  // CG_DATATYPE_MACRO(Float1x2,float1x2,CG_FLOAT1x2,1,2)
  {$EXTERNALSYM cgFloat1x2ValueType}
  cgFloat1x3ValueType = 1051;  // CG_DATATYPE_MACRO(Float1x3,float1x3,CG_FLOAT1x3,1,3)
  {$EXTERNALSYM cgFloat1x3ValueType}
  cgFloat1x4ValueType = 1052;  // CG_DATATYPE_MACRO(Float1x4,float1x4,CG_FLOAT1x4,1,4)
  {$EXTERNALSYM cgFloat1x4ValueType}
  cgFloat2x1ValueType = 1053;  // CG_DATATYPE_MACRO(Float2x1,float2x1,CG_FLOAT2x1,2,1)
  {$EXTERNALSYM cgFloat2x1ValueType}
  cgFloat2x2ValueType = 1054;  // CG_DATATYPE_MACRO(Float2x2,float2x2,CG_FLOAT2x2,2,2)
  {$EXTERNALSYM cgFloat2x2ValueType}
  cgFloat2x3ValueType = 1055;  // CG_DATATYPE_MACRO(Float2x3,float2x3,CG_FLOAT2x3,2,3)
  {$EXTERNALSYM cgFloat2x3ValueType}
  cgFloat2x4ValueType = 1056;  // CG_DATATYPE_MACRO(Float2x4,float2x4,CG_FLOAT2x4,2,4)
  {$EXTERNALSYM cgFloat2x4ValueType}
  cgFloat3x1ValueType = 1057;  // CG_DATATYPE_MACRO(Float3x1,float3x1,CG_FLOAT3x1,3,1)
  {$EXTERNALSYM cgFloat3x1ValueType}
  cgFloat3x2ValueType = 1058;  // CG_DATATYPE_MACRO(Float3x2,float3x2,CG_FLOAT3x2,3,2)
  {$EXTERNALSYM cgFloat3x2ValueType}
  cgFloat3x3ValueType = 1059;  // CG_DATATYPE_MACRO(Float3x3,float3x3,CG_FLOAT3x3,3,3)
  {$EXTERNALSYM cgFloat3x3ValueType}
  cgFloat3x4ValueType = 1060;  // CG_DATATYPE_MACRO(Float3x4,float3x4,CG_FLOAT3x4,3,4)
  {$EXTERNALSYM cgFloat3x4ValueType}
  cgFloat4x1ValueType = 1061;  // CG_DATATYPE_MACRO(Float4x1,float4x1,CG_FLOAT4x1,4,1)
  {$EXTERNALSYM cgFloat4x1ValueType}
  cgFloat4x2ValueType = 1062;  // CG_DATATYPE_MACRO(Float4x2,float4x2,CG_FLOAT4x2,4,2)
  {$EXTERNALSYM cgFloat4x2ValueType}
  cgFloat4x3ValueType = 1063;  // CG_DATATYPE_MACRO(Float4x3,float4x3,CG_FLOAT4x3,4,3)
  {$EXTERNALSYM cgFloat4x3ValueType}
  cgFloat4x4ValueType = 1064;  // CG_DATATYPE_MACRO(Float4x4,float4x4,CG_FLOAT4x4,4,4)
  {$EXTERNALSYM cgFloat4x4ValueType}
  cgSampler1DValueType = 1065; // CG_DATATYPE_MACRO(Sampler1D,sampler1D,CG_SAMPLER1D,0,0)
  {$EXTERNALSYM cgSampler1DValueType}
  cgSampler2DValueType = 1066; // CG_DATATYPE_MACRO(Sampler2D,sampler2D,CG_SAMPLER2D,0,0)
  {$EXTERNALSYM cgSampler2DValueType}
  cgSampler3DValueType = 1067; // CG_DATATYPE_MACRO(Sampler3D,sampler3D,CG_SAMPLER3D,0,0)
  {$EXTERNALSYM cgSampler3DValueType}
  cgSamplerRECTValueType = 1068; // CG_DATATYPE_MACRO(SamplerRECT,samplerRECT,CG_SAMPLERRECT,0,0)
  {$EXTERNALSYM cgSamplerRECTValueType}
  cgSamplerCUBEValueType = 1069; // CG_DATATYPE_MACRO(SamplerCUBE,samplerCUBE,CG_SAMPLERCUBE,0,0)
  {$EXTERNALSYM cgSamplerCUBEValueType}
  cgFixedValueType = 1070;     // CG_DATATYPE_MACRO(Fixed,fixed,CG_FIXED,0,0)
  {$EXTERNALSYM cgFixedValueType}
  cgFixed2ValueType = 1071;    // CCG_DATATYPE_MACRO(Fixed2,fixed2,CG_FIXED2,0,0)
  {$EXTERNALSYM cgFixed2ValueType}
  cgFixed3ValueType = 1072;    // CCG_DATATYPE_MACRO(Fixed3,fixed3,CG_FIXED3,0,0)
  {$EXTERNALSYM cgFixed3ValueType}
  cgFixed4ValueType = 1073;    // CCG_DATATYPE_MACRO(Fixed4,fixed4,CG_FIXED4,0,0)
  {$EXTERNALSYM cgFixed4ValueType}
  cgFixed1x1ValueType = 1074;  // CCG_DATATYPE_MACRO(Fixed1x1,fixed1x1,CG_FIXED1x1,1,1)
  {$EXTERNALSYM cgFixed1x1ValueType}
  cgFixed1x2ValueType = 1075;  // CCG_DATATYPE_MACRO(Fixed1x2,fixed1x2,CG_FIXED1x2,1,2)
  {$EXTERNALSYM cgFixed1x2ValueType}
  cgFixed1x3ValueType = 1076;  // CCG_DATATYPE_MACRO(Fixed1x3,fixed1x3,CG_FIXED1x3,1,3)
  {$EXTERNALSYM cgFixed1x3ValueType}
  cgFixed1x4ValueType = 1077;  // CCG_DATATYPE_MACRO(Fixed1x4,fixed1x4,CG_FIXED1x4,1,4)
  {$EXTERNALSYM cgFixed1x4ValueType}
  cgFixed2x1ValueType = 1078;  // CCG_DATATYPE_MACRO(Fixed2x1,fixed2x1,CG_FIXED2x1,2,1)
  {$EXTERNALSYM cgFixed2x1ValueType}
  cgFixed2x2ValueType = 1079;  // CCG_DATATYPE_MACRO(Fixed2x2,fixed2x2,CG_FIXED2x2,2,2)
  {$EXTERNALSYM cgFixed2x2ValueType}
  cgFixed2x3ValueType = 1080;  // CCG_DATATYPE_MACRO(Fixed2x3,fixed2x3,CG_FIXED2x3,2,3)
  {$EXTERNALSYM cgFixed2x3ValueType}
  cgFixed2x4ValueType = 1081;  // CCG_DATATYPE_MACRO(Fixed2x4,fixed2x4,CG_FIXED2x4,2,4)
  {$EXTERNALSYM cgFixed2x4ValueType}
  cgFixed3x1ValueType = 1082;  // CCG_DATATYPE_MACRO(Fixed3x1,fixed3x1,CG_FIXED3x1,3,1)
  {$EXTERNALSYM cgFixed3x1ValueType}
  cgFixed3x2ValueType = 1083;  // CCG_DATATYPE_MACRO(Fixed3x2,fixed3x2,CG_FIXED3x2,3,2)
  {$EXTERNALSYM cgFixed3x2ValueType}
  cgFixed3x3ValueType = 1084;  // CCG_DATATYPE_MACRO(Fixed3x3,fixed3x3,CG_FIXED3x3,3,3)
  {$EXTERNALSYM cgFixed3x3ValueType}
  cgFixed3x4ValueType = 1085;  // CCG_DATATYPE_MACRO(Fixed3x4,fixed3x4,CG_FIXED3x4,3,4)
  {$EXTERNALSYM cgFixed3x4ValueType}
  cgFixed4x1ValueType = 1086;  // CCG_DATATYPE_MACRO(Fixed4x1,fixed4x1,CG_FIXED4x1,4,1)
  {$EXTERNALSYM cgFixed4x1ValueType}
  cgFixed4x2ValueType = 1087;  // CCG_DATATYPE_MACRO(Fixed4x2,fixed4x2,CG_FIXED4x2,4,2)
  {$EXTERNALSYM cgFixed4x2ValueType}
  cgFixed4x3ValueType = 1088;  // CCG_DATATYPE_MACRO(Fixed4x3,fixed4x3,CG_FIXED4x3,4,3)
  {$EXTERNALSYM cgFixed4x3ValueType}
  cgFixed4x4ValueType = 1089;  // CCG_DATATYPE_MACRO(Fixed4x4,fixed4x4,CG_FIXED4x4,4,4)
  {$EXTERNALSYM cgFixed4x4ValueType}
  cgHalf1ValueType = 1090;     // CCG_DATATYPE_MACRO(Half1,half1,CG_HALF1,0,0)
  {$EXTERNALSYM cgHalf1ValueType}
  cgFloat1ValueType = 1091;    // CCG_DATATYPE_MACRO(Float1,float1,CG_FLOAT1,0,0)
  {$EXTERNALSYM cgFloat1ValueType}
  cgFixed1ValueType = 1092;    // CCG_DATATYPE_MACRO(Fixed1,,,fixed1,CG_FIXED1,0,0),
  {$EXTERNALSYM cgFixed1ValueType}

type
  TcgValueType = DWORD;
{$ENDIF}
  cgValueType = TcgValueType;
  {$NODEFINE cgValueType}
  {$NODEFINE TcgValueType}
  {$HPPEMIT 'typedef cgValueType TcgValueType;'}

type
  TcgParamType = (
    cgConstParam,
    cgUniformParam,
    cgConnectorMemberParam,
{$IFDEF COMPILER6_UP}
    cgVaryingParam = cgConnectorMemberParam,
{$ENDIF}
    cgTexObjParam,
    cgAnyParam,
    cgUndefinedParam
  );
  cgParamType = TcgParamType;
  {$NODEFINE cgParamType}
  {$NODEFINE TcgParamType}
  {$HPPEMIT 'typedef cgParamType TcgParamType;'}

{$IFNDEF COMPILER6_UP}
const
  cgVaryingParam = cgConnectorMemberParam;
  {$EXTERNALSYM cgVaryingParam}

{$ENDIF}
(*
 * The following macro invocations define the supported CG basic hardware
 * bind locations.
 *
 * The macros have the form :
 *
 *   CG_BINDLOCATION_MACRO(name, compiler_name, enum_int)
 *
 *     name          : The name of the location.
 *     enum_name     : The C enumerant.
 *     compiler_name : The name of the location within the compiler syntax.
 *     int_id        : Integer enumerant associated with this bind location.
 *     addressable   : The bind location must have an integer address
 *                     associated with it.
 *     ParamType     : the cgParamType of this register.
 *
 *)
{$IFDEF COMPILER6_UP}
type
  TcgBindLocation = (
  {$IFDEF BCB}
    cgcgBindDummy
  {$ELSE}
    //# define CG_BINDLOCATION_MACRO(name,enum_name,compiler_name,\
    //                               enum_int,addressable,param_type) \
    //  cgBind##name = enum_int,
    cgBindTexUnit0  = 2048, // CG_BINDLOCATION_MACRO(TexUnit0,CG_TEXUNIT0,"texunit 0",2048,0,cgTexObjParam)
    cgBindTexUnit1  = 2049, // CG_BINDLOCATION_MACRO(TexUnit1,CG_TEXUNIT1,"texunit 1",2049,0,cgTexObjParam)
    cgBindTexUnit2  = 2050, // CG_BINDLOCATION_MACRO(TexUnit2,CG_TEXUNIT2,"texunit 2",2050,0,cgTexObjParam)
    cgBindTexUnit3  = 2051, // CG_BINDLOCATION_MACRO(TexUnit3,CG_TEXUNIT3,"texunit 3",2051,0,cgTexObjParam)
    cgBindTexUnit4  = 2052, // CG_BINDLOCATION_MACRO(TexUnit4,CG_TEXUNIT4,"texunit 4",2052,0,cgTexObjParam)
    cgBindTexUnit5  = 2053, // CG_BINDLOCATION_MACRO(TexUnit5,CG_TEXUNIT5,"texunit 5",2053,0,cgTexObjParam)
    cgBindTexUnit6  = 2054, // CG_BINDLOCATION_MACRO(TexUnit6,CG_TEXUNIT6,"texunit 6",2054,0,cgTexObjParam)
    cgBindTexUnit7  = 2055, // CG_BINDLOCATION_MACRO(TexUnit7,CG_TEXUNIT7,"texunit 7",2055,0,cgTexObjParam)
    cgBindTexUnit8  = 2056, // CG_BINDLOCATION_MACRO(TexUnit8,CG_TEXUNIT8,"texunit 8",2056,0,cgTexObjParam)
    cgBindTexUnit9  = 2057, // CG_BINDLOCATION_MACRO(TexUnit9,CG_TEXUNIT9,"texunit 9",2057,0,cgTexObjParam)
    cgBindTexUnit10 = 2058, // CG_BINDLOCATION_MACRO(TexUnit10,CG_TEXUNIT10,"texunit 10",2058,0,cgTexObjParam)
    cgBindTexUnit11 = 2059, // CG_BINDLOCATION_MACRO(TexUnit11,CG_TEXUNIT11,"texunit 11",2059,0,cgTexObjParam)
    cgBindTexUnit12 = 2060, // CG_BINDLOCATION_MACRO(TexUnit12,CG_TEXUNIT12,"texunit 12",2060,0,cgTexObjParam)
    cgBindTexUnit13 = 2061, // CG_BINDLOCATION_MACRO(TexUnit13,CG_TEXUNIT13,"texunit 13",2061,0,cgTexObjParam)
    cgBindTexUnit14 = 2062, // CG_BINDLOCATION_MACRO(TexUnit14,CG_TEXUNIT14,"texunit 14",2062,0,cgTexObjParam)
    cgBindTexUnit15 = 2063, // CG_BINDLOCATION_MACRO(TexUnit15,CG_TEXUNIT15,"texunit 15",2063,0,cgTexObjParam)

    cgBindAttr0     = 2113, // CG_BINDLOCATION_MACRO(Attr0,CG_ATTR0,"ATTR0",2113,0,cgConnectorMemberParam)
    cgBindAttr1     = 2114, // CCG_BINDLOCATION_MACRO(Attr1,CG_ATTR1,"ATTR1",2114,0,cgConnectorMemberParam)
    cgBindAttr2     = 2115, // CCG_BINDLOCATION_MACRO(Attr2,CG_ATTR2,"ATTR2",2115,0,cgConnectorMemberParam)
    cgBindAttr3     = 2116, // CCG_BINDLOCATION_MACRO(Attr3,CG_ATTR3,"ATTR3",2116,0,cgConnectorMemberParam)
    cgBindAttr4     = 2117, // CCG_BINDLOCATION_MACRO(Attr4,CG_ATTR4,"ATTR4",2117,0,cgConnectorMemberParam)
    cgBindAttr5     = 2118, // CCG_BINDLOCATION_MACRO(Attr5,CG_ATTR5,"ATTR5",2118,0,cgConnectorMemberParam)
    cgBindAttr6     = 2119, // CCG_BINDLOCATION_MACRO(Attr6,CG_ATTR6,"ATTR6",2119,0,cgConnectorMemberParam)
    cgBindAttr7     = 2120, // CCG_BINDLOCATION_MACRO(Attr7,CG_ATTR7,"ATTR7",2120,0,cgConnectorMemberParam)
    cgBindAttr8     = 2121, // CCG_BINDLOCATION_MACRO(Attr8,CG_ATTR8,"ATTR8",2121,0,cgConnectorMemberParam)
    cgBindAttr9     = 2122, // CCG_BINDLOCATION_MACRO(Attr9,CG_ATTR9,"ATTR9",2122,0,cgConnectorMemberParam)
    cgBindAttr10    = 2123, // CCG_BINDLOCATION_MACRO(Attr10,CG_ATTR10,"ATTR10",2123,0,cgConnectorMemberParam)
    cgBindAttr11    = 2124, // CCG_BINDLOCATION_MACRO(Attr11,CG_ATTR11,"ATTR11",2124,0,cgConnectorMemberParam)
    cgBindAttr12    = 2125, // CCG_BINDLOCATION_MACRO(Attr12,CG_ATTR12,"ATTR12",2125,0,cgConnectorMemberParam)
    cgBindAttr13    = 2126, // CCG_BINDLOCATION_MACRO(Attr13,CG_ATTR13,"ATTR13",2126,0,cgConnectorMemberParam)
    cgBindAttr14    = 2127, // CCG_BINDLOCATION_MACRO(Attr14,CG_ATTR14,"ATTR14",2127,0,cgConnectorMemberParam)
    cgBindAttr15    = 2128, // CCG_BINDLOCATION_MACRO(Attr15,CG_ATTR15,"ATTR15",2128,0,cgConnectorMemberParam)

    cgBindVertUniform = 2178, // CCG_BINDLOCATION_MACRO(VertUniform,CG_C,"c",2178,1,cgUniformParam)

    cgBindTex0      = 2179, // CG_BINDLOCATION_MACRO(Tex0,CG_TEX0,"TEX0",2179,0,cgConnectorMemberParam)
    cgBindTex1      = 2180, // CG_BINDLOCATION_MACRO(Tex1,CG_TEX1,"TEX1",2180,0,cgConnectorMemberParam)
    cgBindTex2      = 2181, // CG_BINDLOCATION_MACRO(Tex2,CG_TEX2,"TEX2",2181,0,cgConnectorMemberParam)
    cgBindTex3      = 2192, // CG_BINDLOCATION_MACRO(Tex3,CG_TEX3,"TEX3",2192,0,cgConnectorMemberParam)
    cgBindTex4      = 2193, // CG_BINDLOCATION_MACRO(Tex4,CG_TEX4,"TEX4",2193,0,cgConnectorMemberParam)
    cgBindTex5      = 2194, // CG_BINDLOCATION_MACRO(Tex5,CG_TEX5,"TEX5",2194,0,cgConnectorMemberParam)
    cgBindTex6      = 2195, // CG_BINDLOCATION_MACRO(Tex6,CG_TEX6,"TEX6",2195,0,cgConnectorMemberParam)
    cgBindTex7      = 2196, // CG_BINDLOCATION_MACRO(Tex7,CG_TEX7,"TEX7",2196,0,cgConnectorMemberParam)

    cgBindHPos      = 2243, // CG_BINDLOCATION_MACRO(HPos,CG_HPOS,"HPOS",2243,0,cgConnectorMemberParam)
    cgBindCol0      = 2245, // CG_BINDLOCATION_MACRO(Col0,CG_COL0,"COL0",2245,0,cgConnectorMemberParam)
    cgBindCol1      = 2246, // CG_BINDLOCATION_MACRO(Col1,CG_COL1,"COL1",2246,0,cgConnectorMemberParam)
    cgBindCol2      = 2247, // CG_BINDLOCATION_MACRO(Col2,CG_COL2,"COL2",2247,0,cgConnectorMemberParam)
    cgBindCol3      = 2248, // CG_BINDLOCATION_MACRO(Col3,CG_COL3,"COL3",2248,0,cgConnectorMemberParam)
    cgBindPSiz      = 2309, // CG_BINDLOCATION_MACRO(PSiz,CG_PSIZ,"PSIZ",2309,0,cgConnectorMemberParam)
    cgBindWPos      = 2373, // CG_BINDLOCATION_MACRO(WPos,CG_WPOS,"WPOS",2373,0,cgConnectorMemberParam)

    cgBindPosition0 = 2437, // CG_BINDLOCATION_MACRO(Position0,CG_POSITION0,"POSITION0",2437,0,cgConnectorMemberParam)
    cgBindPosition1 = 2438, // CG_BINDLOCATION_MACRO(Position1,CG_POSITION1,"POSITION1",2438,0,cgConnectorMemberParam)
    cgBindPosition2 = 2439, // CG_BINDLOCATION_MACRO(Position2,CG_POSITION2,"POSITION2",2439,0,cgConnectorMemberParam)
    cgBindPosition3 = 2440, // CG_BINDLOCATION_MACRO(Position3,CG_POSITION3,"POSITION3",2440,0,cgConnectorMemberParam)
    cgBindPosition4 = 2441, // CG_BINDLOCATION_MACRO(Position4,CG_POSITION4,"POSITION4",2441,0,cgConnectorMemberParam)
    cgBindPosition5 = 2442, // CG_BINDLOCATION_MACRO(Position5,CG_POSITION5,"POSITION5",2442,0,cgConnectorMemberParam)
    cgBindPosition6 = 2443, // CG_BINDLOCATION_MACRO(Position6,CG_POSITION6,"POSITION6",2443,0,cgConnectorMemberParam)
    cgBindPosition7 = 2444, // CG_BINDLOCATION_MACRO(Position7,CG_POSITION7,"POSITION7",2444,0,cgConnectorMemberParam)
    cgBindPosition8 = 2445, // CG_BINDLOCATION_MACRO(Position8,CG_POSITION8,"POSITION8",2445,0,cgConnectorMemberParam)
    cgBindPosition9 = 2446, // CG_BINDLOCATION_MACRO(Position9,CG_POSITION9,"POSITION9",2446,0,cgConnectorMemberParam)
    cgBindPosition10= 2447, // CG_BINDLOCATION_MACRO(Position10,CG_POSITION10,"POSITION10",2447,0,cgConnectorMemberParam)
    cgBindPosition11= 2448, // CG_BINDLOCATION_MACRO(Position11,CG_POSITION11,"POSITION11",2448,0,cgConnectorMemberParam)
    cgBindPosition12= 2449, // CG_BINDLOCATION_MACRO(Position12,CG_POSITION12,"POSITION12",2449,0,cgConnectorMemberParam)
    cgBindPosition13= 2450, // CG_BINDLOCATION_MACRO(Position13,CG_POSITION13,"POSITION13",2450,0,cgConnectorMemberParam)
    cgBindPosition14= 2451, // CG_BINDLOCATION_MACRO(Position14,CG_POSITION14,"POSITION14",2451,0,cgConnectorMemberParam)
    cgBindPosition15= 2452, // CG_BINDLOCATION_MACRO(Position15,CG_POSITION15,"POSITION15",2452,0,cgConnectorMemberParam)
    cgBindDiffuse0  = 2501, // CG_BINDLOCATION_MACRO(Diffuse0,CG_DIFFUSE0,"DIFFUSE0",2501,0,cgConnectorMemberParam)
    cgBindTangent0  = 2565, // CG_BINDLOCATION_MACRO(Tangent0,CG_TANGENT0,"TANGENT0",2565,0,cgConnectorMemberParam)
    cgBindTangent1  = 2566, // CG_BINDLOCATION_MACRO(Tangent1,CG_TANGENT1,"TANGENT1",2566,0,cgConnectorMemberParam)
    cgBindTangent2  = 2567, // CG_BINDLOCATION_MACRO(Tangent2,CG_TANGENT2,"TANGENT2",2567,0,cgConnectorMemberParam)
    cgBindTangent3  = 2568, // CG_BINDLOCATION_MACRO(Tangent3,CG_TANGENT3,"TANGENT3",2568,0,cgConnectorMemberParam)
    cgBindTangent4  = 2569, // CG_BINDLOCATION_MACRO(Tangent4,CG_TANGENT4,"TANGENT4",2569,0,cgConnectorMemberParam)
    cgBindTangent5  = 2570, // CG_BINDLOCATION_MACRO(Tangent5,CG_TANGENT5,"TANGENT5",2570,0,cgConnectorMemberParam)
    cgBindTangent6  = 2571, // CG_BINDLOCATION_MACRO(Tangent6,CG_TANGENT6,"TANGENT6",2571,0,cgConnectorMemberParam)
    cgBindTangent7  = 2572, // CG_BINDLOCATION_MACRO(Tangent7,CG_TANGENT7,"TANGENT7",2572,0,cgConnectorMemberParam)
    cgBindTangent8  = 2573, // CG_BINDLOCATION_MACRO(Tangent8,CG_TANGENT8,"TANGENT8",2573,0,cgConnectorMemberParam)
    cgBindTangent9  = 2574, // CG_BINDLOCATION_MACRO(Tangent9,CG_TANGENT9,"TANGENT9",2574,0,cgConnectorMemberParam)
    cgBindTangent10 = 2575, // CG_BINDLOCATION_MACRO(Tangent10,CG_TANGENT10,"TANGENT10",2575,0,cgConnectorMemberParam)
    cgBindTangent11 = 2576, // CG_BINDLOCATION_MACRO(Tangent11,CG_TANGENT11,"TANGENT11",2576,0,cgConnectorMemberParam)
    cgBindTangent12 = 2577, // CG_BINDLOCATION_MACRO(Tangent12,CG_TANGENT12,"TANGENT12",2577,0,cgConnectorMemberParam)
    cgBindTangent13 = 2578, // CG_BINDLOCATION_MACRO(Tangent13,CG_TANGENT13,"TANGENT13",2578,0,cgConnectorMemberParam)
    cgBindTangent14 = 2579, // CG_BINDLOCATION_MACRO(Tangent14,CG_TANGENT14,"TANGENT14",2579,0,cgConnectorMemberParam)
    cgBindTangent15 = 2580, // CG_BINDLOCATION_MACRO(Tangent15,CG_TANGENT15,"TANGENT15",2580,0,cgConnectorMemberParam)
    cgBindSpecular0 = 2629, // CG_BINDLOCATION_MACRO(Specular0,CG_SPECULAR0,"SPECULAR0",2629,0,cgConnectorMemberParam)
    cgBindBlendIndices0 = 2693, // CG_BINDLOCATION_MACRO(BlendIndices0,CG_BLENDINDICES0,"BLENDINDICES0",2693,0,cgConnectorMemberParam)
    cgBindBlendIndices1 = 2694, // CG_BINDLOCATION_MACRO(BlendIndices1,CG_BLENDINDICES1,"BLENDINDICES1",2694,0,cgConnectorMemberParam)
    cgBindBlendIndices2 = 2695, // CG_BINDLOCATION_MACRO(BlendIndices2,CG_BLENDINDICES2,"BLENDINDICES2",2695,0,cgConnectorMemberParam)
    cgBindBlendIndices3 = 2696, // CG_BINDLOCATION_MACRO(BlendIndices3,CG_BLENDINDICES3,"BLENDINDICES3",2696,0,cgConnectorMemberParam)
    cgBindBlendIndices4 = 2697, // CG_BINDLOCATION_MACRO(BlendIndices4,CG_BLENDINDICES4,"BLENDINDICES4",2697,0,cgConnectorMemberParam)
    cgBindBlendIndices5 = 2698, // CG_BINDLOCATION_MACRO(BlendIndices5,CG_BLENDINDICES5,"BLENDINDICES5",2698,0,cgConnectorMemberParam)
    cgBindBlendIndices6 = 2699, // CG_BINDLOCATION_MACRO(BlendIndices6,CG_BLENDINDICES6,"BLENDINDICES6",2699,0,cgConnectorMemberParam)
    cgBindBlendIndices7 = 2700, // CG_BINDLOCATION_MACRO(BlendIndices7,CG_BLENDINDICES7,"BLENDINDICES7",2700,0,cgConnectorMemberParam)
    cgBindBlendIndices8 = 2701, // CG_BINDLOCATION_MACRO(BlendIndices8,CG_BLENDINDICES8,"BLENDINDICES8",2701,0,cgConnectorMemberParam)
    cgBindBlendIndices9 = 2702, // CG_BINDLOCATION_MACRO(BlendIndices9,CG_BLENDINDICES9,"BLENDINDICES9",2702,0,cgConnectorMemberParam)
    cgBindBlendIndices10 = 2703, // CG_BINDLOCATION_MACRO(BlendIndices10,CG_BLENDINDICES10,"BLENDINDICES10",2703,0,cgConnectorMemberParam)
    cgBindBlendIndices11 = 2704, // CG_BINDLOCATION_MACRO(BlendIndices11,CG_BLENDINDICES11,"BLENDINDICES11",2704,0,cgConnectorMemberParam)
    cgBindBlendIndices12 = 2705, // CG_BINDLOCATION_MACRO(BlendIndices12,CG_BLENDINDICES12,"BLENDINDICES12",2705,0,cgConnectorMemberParam)
    cgBindBlendIndices13 = 2706, // CG_BINDLOCATION_MACRO(BlendIndices13,CG_BLENDINDICES13,"BLENDINDICES13",2706,0,cgConnectorMemberParam)
    cgBindBlendIndices14 = 2707, // CG_BINDLOCATION_MACRO(BlendIndices14,CG_BLENDINDICES14,"BLENDINDICES14",2707,0,cgConnectorMemberParam)
    cgBindBlendIndices15 = 2708, // CG_BINDLOCATION_MACRO(BlendIndices15,CG_BLENDINDICES15,"BLENDINDICES15",2708,0,cgConnectorMemberParam)
    cgBindColor0    = 2757, // CG_BINDLOCATION_MACRO(Color0,CG_COLOR0,"COLOR0",2757,0,cgConnectorMemberParam)
    cgBindColor1    = 2758, // CG_BINDLOCATION_MACRO(Color1,CG_COLOR1,"COLOR1",2758,0,cgConnectorMemberParam)
    cgBindColor2    = 2759, // CG_BINDLOCATION_MACRO(Color2,CG_COLOR2,"COLOR2",2759,0,cgConnectorMemberParam)
    cgBindColor3    = 2760, // CG_BINDLOCATION_MACRO(Color3,CG_COLOR3,"COLOR3",2760,0,cgConnectorMemberParam)
    cgBindColor4    = 2761, // CG_BINDLOCATION_MACRO(Color4,CG_COLOR4,"COLOR4",2761,0,cgConnectorMemberParam)
    cgBindColor5    = 2762, // CG_BINDLOCATION_MACRO(Color5,CG_COLOR5,"COLOR5",2762,0,cgConnectorMemberParam)
    cgBindColor6    = 2763, // CG_BINDLOCATION_MACRO(Color6,CG_COLOR6,"COLOR6",2763,0,cgConnectorMemberParam)
    cgBindColor7    = 2764, // CG_BINDLOCATION_MACRO(Color7,CG_COLOR7,"COLOR7",2764,0,cgConnectorMemberParam)
    cgBindColor8    = 2765, // CG_BINDLOCATION_MACRO(Color8,CG_COLOR8,"COLOR8",2765,0,cgConnectorMemberParam)
    cgBindColor9    = 2766, // CG_BINDLOCATION_MACRO(Color9,CG_COLOR9,"COLOR9",2766,0,cgConnectorMemberParam)
    cgBindColor10   = 2767, // CG_BINDLOCATION_MACRO(Color10,CG_COLOR10,"COLOR10",2767,0,cgConnectorMemberParam)
    cgBindColor11   = 2768, // CG_BINDLOCATION_MACRO(Color11,CG_COLOR11,"COLOR11",2768,0,cgConnectorMemberParam)
    cgBindColor12   = 2769, // CG_BINDLOCATION_MACRO(Color12,CG_COLOR12,"COLOR12",2769,0,cgConnectorMemberParam)
    cgBindColor13   = 2770, // CG_BINDLOCATION_MACRO(Color13,CG_COLOR13,"COLOR13",2770,0,cgConnectorMemberParam)
    cgBindColor14   = 2771, // CG_BINDLOCATION_MACRO(Color14,CG_COLOR14,"COLOR14",2771,0,cgConnectorMemberParam)
    cgBindColor15   = 2772, // CG_BINDLOCATION_MACRO(Color15,CG_COLOR15,"COLOR15",2772,0,cgConnectorMemberParam)
    cgBindPSize0    = 2821, // CG_BINDLOCATION_MACRO(PSize0,CG_PSIZE0,"PSIZE0",2821,0,cgConnectorMemberParam)
    cgBindPSize1    = 2822, // CG_BINDLOCATION_MACRO(PSize1,CG_PSIZE1,"PSIZE1",2822,0,cgConnectorMemberParam)
    cgBindPSize2    = 2823, // CG_BINDLOCATION_MACRO(PSize2,CG_PSIZE2,"PSIZE2",2823,0,cgConnectorMemberParam)
    cgBindPSize3    = 2824, // CG_BINDLOCATION_MACRO(PSize3,CG_PSIZE3,"PSIZE3",2824,0,cgConnectorMemberParam)
    cgBindPSize4    = 2825, // CG_BINDLOCATION_MACRO(PSize4,CG_PSIZE4,"PSIZE4",2825,0,cgConnectorMemberParam)
    cgBindPSize5    = 2826, // CG_BINDLOCATION_MACRO(PSize5,CG_PSIZE5,"PSIZE5",2826,0,cgConnectorMemberParam)
    cgBindPSize6    = 2827, // CG_BINDLOCATION_MACRO(PSize6,CG_PSIZE6,"PSIZE6",2827,0,cgConnectorMemberParam)
    cgBindPSize7    = 2828, // CG_BINDLOCATION_MACRO(PSize7,CG_PSIZE7,"PSIZE7",2828,0,cgConnectorMemberParam)
    cgBindPSize8    = 2829, // CG_BINDLOCATION_MACRO(PSize8,CG_PSIZE8,"PSIZE8",2829,0,cgConnectorMemberParam)
    cgBindPSize9    = 2830, // CG_BINDLOCATION_MACRO(PSize9,CG_PSIZE9,"PSIZE9",2830,0,cgConnectorMemberParam)
    cgBindPSize10   = 2831, // CG_BINDLOCATION_MACRO(PSize10,CG_PSIZE10,"PSIZE10",2831,0,cgConnectorMemberParam)
    cgBindPSize11   = 2832, // CG_BINDLOCATION_MACRO(PSize11,CG_PSIZE11,"PSIZE11",2832,0,cgConnectorMemberParam)
    cgBindPSize12   = 2833, // CG_BINDLOCATION_MACRO(PSize12,CG_PSIZE12,"PSIZE12",2833,0,cgConnectorMemberParam)
    cgBindPSize13   = 2834, // CG_BINDLOCATION_MACRO(PSize13,CG_PSIZE13,"PSIZE13",2834,0,cgConnectorMemberParam)
    cgBindPSize14   = 2835, // CG_BINDLOCATION_MACRO(PSize14,CG_PSIZE14,"PSIZE14",2835,0,cgConnectorMemberParam)
    cgBindPSize15   = 2836, // CG_BINDLOCATION_MACRO(PSize15,CG_PSIZE15,"PSIZE15",2836,0,cgConnectorMemberParam)
    cgBindBiNormal0 = 2885, // CG_BINDLOCATION_MACRO(BiNormal0,CG_BINORMAL0,"BINORMAL0",2885,0,cgConnectorMemberParam)
    cgBindBiNormal1 = 2886, // CG_BINDLOCATION_MACRO(BiNormal1,CG_BINORMAL1,"BINORMAL1",2886,0,cgConnectorMemberParam)
    cgBindBiNormal2 = 2887, // CG_BINDLOCATION_MACRO(BiNormal2,CG_BINORMAL2,"BINORMAL2",2887,0,cgConnectorMemberParam)
    cgBindBiNormal3 = 2888, // CG_BINDLOCATION_MACRO(BiNormal3,CG_BINORMAL3,"BINORMAL3",2888,0,cgConnectorMemberParam)
    cgBindBiNormal4 = 2889, // CG_BINDLOCATION_MACRO(BiNormal4,CG_BINORMAL4,"BINORMAL4",2889,0,cgConnectorMemberParam)
    cgBindBiNormal5 = 2890, // CG_BINDLOCATION_MACRO(BiNormal5,CG_BINORMAL5,"BINORMAL5",2890,0,cgConnectorMemberParam)
    cgBindBiNormal6 = 2891, // CG_BINDLOCATION_MACRO(BiNormal6,CG_BINORMAL6,"BINORMAL6",2891,0,cgConnectorMemberParam)
    cgBindBiNormal7 = 2892, // CG_BINDLOCATION_MACRO(BiNormal7,CG_BINORMAL7,"BINORMAL7",2892,0,cgConnectorMemberParam)
    cgBindBiNormal8 = 2893, // CG_BINDLOCATION_MACRO(BiNormal8,CG_BINORMAL8,"BINORMAL8",2893,0,cgConnectorMemberParam)
    cgBindBiNormal9 = 2894, // CG_BINDLOCATION_MACRO(BiNormal9,CG_BINORMAL9,"BINORMAL9",2894,0,cgConnectorMemberParam)
    cgBindBiNormal10= 2895, // CG_BINDLOCATION_MACRO(BiNormal10,CG_BINORMAL10,"BINORMAL10",2895,0,cgConnectorMemberParam)
    cgBindBiNormal11= 2896, // CG_BINDLOCATION_MACRO(BiNormal11,CG_BINORMAL11,"BINORMAL11",2896,0,cgConnectorMemberParam)
    cgBindBiNormal12= 2897, // CG_BINDLOCATION_MACRO(BiNormal12,CG_BINORMAL12,"BINORMAL12",2897,0,cgConnectorMemberParam)
    cgBindBiNormal13= 2898, // CG_BINDLOCATION_MACRO(BiNormal13,CG_BINORMAL13,"BINORMAL13",2898,0,cgConnectorMemberParam)
    cgBindBiNormal14= 2899, // CG_BINDLOCATION_MACRO(BiNormal14,CG_BINORMAL14,"BINORMAL14",2899,0,cgConnectorMemberParam)
    cgBindBiNormal15= 2900, // CG_BINDLOCATION_MACRO(BiNormal15,CG_BINORMAL15,"BINORMAL15",2900,0,cgConnectorMemberParam)
    cgBindFOG0      = 2917, // CG_BINDLOCATION_MACRO(FOG0,CG_FOG0,"FOG0",2917,0,cgConnectorMemberParam)
    cgBindFOG1      = 2918, // CG_BINDLOCATION_MACRO(FOG1,CG_FOG1,"FOG1",2918,0,cgConnectorMemberParam)
    cgBindFOG2      = 2919, // CG_BINDLOCATION_MACRO(FOG2,CG_FOG2,"FOG2",2919,0,cgConnectorMemberParam)
    cgBindFOG3      = 2920, // CG_BINDLOCATION_MACRO(FOG3,CG_FOG3,"FOG3",2920,0,cgConnectorMemberParam)
    cgBindFOG4      = 2921, // CG_BINDLOCATION_MACRO(FOG4,CG_FOG4,"FOG4",2921,0,cgConnectorMemberParam)
    cgBindFOG5      = 2922, // CG_BINDLOCATION_MACRO(FOG5,CG_FOG5,"FOG5",2922,0,cgConnectorMemberParam)
    cgBindFOG6      = 2923, // CG_BINDLOCATION_MACRO(FOG6,CG_FOG6,"FOG6",2923,0,cgConnectorMemberParam)
    cgBindFOG7      = 2924, // CG_BINDLOCATION_MACRO(FOG7,CG_FOG7,"FOG7",2924,0,cgConnectorMemberParam)
    cgBindFOG8      = 2925, // CG_BINDLOCATION_MACRO(FOG8,CG_FOG8,"FOG8",2925,0,cgConnectorMemberParam)
    cgBindFOG9      = 2926, // CG_BINDLOCATION_MACRO(FOG9,CG_FOG9,"FOG9",2926,0,cgConnectorMemberParam)
    cgBindFOG10     = 2927, // CG_BINDLOCATION_MACRO(FOG10,CG_FOG10,"FOG10",2927,0,cgConnectorMemberParam)
    cgBindFOG11     = 2928, // CG_BINDLOCATION_MACRO(FOG11,CG_FOG11,"FOG11",2928,0,cgConnectorMemberParam)
    cgBindFOG12     = 2929, // CG_BINDLOCATION_MACRO(FOG12,CG_FOG12,"FOG12",2929,0,cgConnectorMemberParam)
    cgBindFOG13     = 2930, // CG_BINDLOCATION_MACRO(FOG13,CG_FOG13,"FOG13",2930,0,cgConnectorMemberParam)
    cgBindFOG14     = 2931, // CG_BINDLOCATION_MACRO(FOG14,CG_FOG14,"FOG14",2931,0,cgConnectorMemberParam)
    cgBindFOG15     = 2932, // CG_BINDLOCATION_MACRO(FOG15,CG_FOG15,"FOG15",2932,0,cgConnectorMemberParam)
    cgBindDEPTH0    = 2933, // CG_BINDLOCATION_MACRO(DEPTH0,CG_DEPTH0,"DEPTH0",2933,0,cgConnectorMemberParam)
    cgBindDEPTH1    = 2934, // CG_BINDLOCATION_MACRO(DEPTH1,CG_DEPTH1,"DEPTH1",2934,0,cgConnectorMemberParam)
    cgBindDEPTH2    = 2935, // CG_BINDLOCATION_MACRO(DEPTH2,CG_DEPTH2,"DEPTH2",2935,0,cgConnectorMemberParam)
    cgBindDEPTH3    = 2936, // CG_BINDLOCATION_MACRO(DEPTH3,CG_DEPTH3,"DEPTH3",2936,0,cgConnectorMemberParam)
    cgBindDEPTH4    = 2937, // CG_BINDLOCATION_MACRO(DEPTH4,CG_DEPTH4,"DEPTH4",2937,0,cgConnectorMemberParam)
    cgBindDEPTH5    = 2938, // CG_BINDLOCATION_MACRO(DEPTH5,CG_DEPTH5,"DEPTH5",2938,0,cgConnectorMemberParam)
    cgBindDEPTH6    = 2939, // CG_BINDLOCATION_MACRO(DEPTH6,CG_DEPTH6,"DEPTH6",2939,0,cgConnectorMemberParam)
    cgBindDEPTH7    = 2940, // CG_BINDLOCATION_MACRO(DEPTH7,CG_DEPTH7,"DEPTH7",2940,0,cgConnectorMemberParam)
    cgBindDEPTH8    = 2941, // CG_BINDLOCATION_MACRO(DEPTH8,CG_DEPTH8,"DEPTH8",2941,0,cgConnectorMemberParam)
    cgBindDEPTH9    = 29542, // CG_BINDLOCATION_MACRO(DEPTH9,CG_DEPTH9,"DEPTH9",29542,0,cgConnectorMemberParam) //TODO: what THE @#$% !!! ('29542')
    cgBindDEPTH10   = 2943, // CG_BINDLOCATION_MACRO(DEPTH10,CG_DEPTH10,"DEPTH10",2943,0,cgConnectorMemberParam)
    cgBindDEPTH11   = 2944, // CG_BINDLOCATION_MACRO(DEPTH11,CG_DEPTH11,"DEPTH11",2944,0,cgConnectorMemberParam)
    cgBindDEPTH12   = 2945, // CG_BINDLOCATION_MACRO(DEPTH12,CG_DEPTH12,"DEPTH12",2945,0,cgConnectorMemberParam)
    cgBindDEPTH13   = 2946, // CG_BINDLOCATION_MACRO(DEPTH13,CG_DEPTH13,"DEPTH13",2946,0,cgConnectorMemberParam)
    cgBindDEPTH14   = 2947, // CG_BINDLOCATION_MACRO(DEPTH14,CG_DEPTH14,"DEPTH14",2947,0,cgConnectorMemberParam)
    cgBindDEPTH15   = 2948, // CG_BINDLOCATION_MACRO(DEPTH15,CG_DEPTH15,"DEPTH15",2948,0,cgConnectorMemberParam)
    cgBindSAMPLE0   = 2949, // CG_BINDLOCATION_MACRO(SAMPLE0,CG_SAMPLE0,"SAMPLE0",2949,0,cgConnectorMemberParam)
    cgBindSAMPLE1   = 2950, // CG_BINDLOCATION_MACRO(SAMPLE1,CG_SAMPLE1,"SAMPLE1",2950,0,cgConnectorMemberParam)
    cgBindSAMPLE2   = 2951, // CG_BINDLOCATION_MACRO(SAMPLE2,CG_SAMPLE2,"SAMPLE2",2951,0,cgConnectorMemberParam)
    cgBindSAMPLE3   = 2952, // CG_BINDLOCATION_MACRO(SAMPLE3,CG_SAMPLE3,"SAMPLE3",2952,0,cgConnectorMemberParam)
    cgBindSAMPLE4   = 2953, // CG_BINDLOCATION_MACRO(SAMPLE4,CG_SAMPLE4,"SAMPLE4",2953,0,cgConnectorMemberParam)
    cgBindSAMPLE5   = 2954, // CG_BINDLOCATION_MACRO(SAMPLE5,CG_SAMPLE5,"SAMPLE5",2954,0,cgConnectorMemberParam)
    cgBindSAMPLE6   = 2955, // CG_BINDLOCATION_MACRO(SAMPLE6,CG_SAMPLE6,"SAMPLE6",2955,0,cgConnectorMemberParam)
    cgBindSAMPLE7   = 2956, // CG_BINDLOCATION_MACRO(SAMPLE7,CG_SAMPLE7,"SAMPLE7",2956,0,cgConnectorMemberParam)
    cgBindSAMPLE8   = 2957, // CG_BINDLOCATION_MACRO(SAMPLE8,CG_SAMPLE8,"SAMPLE8",2957,0,cgConnectorMemberParam)
    cgBindSAMPLE9   = 2958, // CG_BINDLOCATION_MACRO(SAMPLE9,CG_SAMPLE9,"SAMPLE9",2958,0,cgConnectorMemberParam)
    cgBindSAMPLE10  = 2959, // CG_BINDLOCATION_MACRO(SAMPLE10,CG_SAMPLE10,"SAMPLE10",2959,0,cgConnectorMemberParam)
    cgBindSAMPLE11  = 2960, // CG_BINDLOCATION_MACRO(SAMPLE11,CG_SAMPLE11,"SAMPLE11",2960,0,cgConnectorMemberParam)
    cgBindSAMPLE12  = 2961, // CG_BINDLOCATION_MACRO(SAMPLE12,CG_SAMPLE12,"SAMPLE12",2961,0,cgConnectorMemberParam)
    cgBindSAMPLE13  = 2962, // CG_BINDLOCATION_MACRO(SAMPLE13,CG_SAMPLE13,"SAMPLE13",2962,0,cgConnectorMemberParam)
    cgBindSAMPLE14  = 2963, // CG_BINDLOCATION_MACRO(SAMPLE14,CG_SAMPLE14,"SAMPLE14",2963,0,cgConnectorMemberParam)
    cgBindSAMPLE15  = 2964, // CG_BINDLOCATION_MACRO(SAMPLE15,CG_SAMPLE15,"SAMPLE15",2964,0,cgConnectorMemberParam)
    cgBindBlendWeight0 = 3028, // CG_BINDLOCATION_MACRO(BlendWeight0,CG_BLENDWEIGHT0,"BLENDWEIGHT0",3028,0,cgConnectorMemberParam)
    cgBindBlendWeight1 = 3029, // CG_BINDLOCATION_MACRO(BlendWeight1,CG_BLENDWEIGHT1,"BLENDWEIGHT1",3029,0,cgConnectorMemberParam)
    cgBindBlendWeight2 = 3030, // CG_BINDLOCATION_MACRO(BlendWeight2,CG_BLENDWEIGHT2,"BLENDWEIGHT2",3030,0,cgConnectorMemberParam)
    cgBindBlendWeight3 = 3031, // CG_BINDLOCATION_MACRO(BlendWeight3,CG_BLENDWEIGHT3,"BLENDWEIGHT3",3031,0,cgConnectorMemberParam)
    cgBindBlendWeight4 = 3032, // CG_BINDLOCATION_MACRO(BlendWeight4,CG_BLENDWEIGHT4,"BLENDWEIGHT4",3032,0,cgConnectorMemberParam)
    cgBindBlendWeight5 = 3033, // CG_BINDLOCATION_MACRO(BlendWeight5,CG_BLENDWEIGHT5,"BLENDWEIGHT5",3033,0,cgConnectorMemberParam)
    cgBindBlendWeight6 = 3034, // CG_BINDLOCATION_MACRO(BlendWeight6,CG_BLENDWEIGHT6,"BLENDWEIGHT6",3034,0,cgConnectorMemberParam)
    cgBindBlendWeight7 = 3035, // CG_BINDLOCATION_MACRO(BlendWeight7,CG_BLENDWEIGHT7,"BLENDWEIGHT7",3035,0,cgConnectorMemberParam)
    cgBindBlendWeight8 = 3036, // CG_BINDLOCATION_MACRO(BlendWeight8,CG_BLENDWEIGHT8,"BLENDWEIGHT8",3036,0,cgConnectorMemberParam)
    cgBindBlendWeight9 = 3037, // CG_BINDLOCATION_MACRO(BlendWeight9,CG_BLENDWEIGHT9,"BLENDWEIGHT9",3037,0,cgConnectorMemberParam)
    cgBindBlendWeight10= 3038, // CG_BINDLOCATION_MACRO(BlendWeight10,CG_BLENDWEIGHT10,"BLENDWEIGHT10",3038,0,cgConnectorMemberParam)
    cgBindBlendWeight11= 3039, // CG_BINDLOCATION_MACRO(BlendWeight11,CG_BLENDWEIGHT11,"BLENDWEIGHT11",3039,0,cgConnectorMemberParam)
    cgBindBlendWeight12= 3040, // CG_BINDLOCATION_MACRO(BlendWeight12,CG_BLENDWEIGHT12,"BLENDWEIGHT12",3040,0,cgConnectorMemberParam)
    cgBindBlendWeight13= 3041, // CG_BINDLOCATION_MACRO(BlendWeight13,CG_BLENDWEIGHT13,"BLENDWEIGHT13",3041,0,cgConnectorMemberParam)
    cgBindBlendWeight14= 3042, // CG_BINDLOCATION_MACRO(BlendWeight14,CG_BLENDWEIGHT14,"BLENDWEIGHT14",3042,0,cgConnectorMemberParam)
    cgBindBlendWeight15= 3043, // CG_BINDLOCATION_MACRO(BlendWeight15,CG_BLENDWEIGHT15,"BLENDWEIGHT15",3043,0,cgConnectorMemberParam)
    cgBindNormal0   = 3092, // CG_BINDLOCATION_MACRO(Normal0,CG_NORMAL0,"NORMAL0",3092,0,cgConnectorMemberParam)
    cgBindNormal1   = 3093, // CG_BINDLOCATION_MACRO(Normal1,CG_NORMAL1,"NORMAL1",3093,0,cgConnectorMemberParam)
    cgBindNormal2   = 3094, // CG_BINDLOCATION_MACRO(Normal2,CG_NORMAL2,"NORMAL2",3094,0,cgConnectorMemberParam)
    cgBindNormal3   = 3095, // CG_BINDLOCATION_MACRO(Normal3,CG_NORMAL3,"NORMAL3",3095,0,cgConnectorMemberParam)
    cgBindNormal4   = 3096, // CG_BINDLOCATION_MACRO(Normal4,CG_NORMAL4,"NORMAL4",3096,0,cgConnectorMemberParam)
    cgBindNormal5   = 3097, // CG_BINDLOCATION_MACRO(Normal5,CG_NORMAL5,"NORMAL5",3097,0,cgConnectorMemberParam)
    cgBindNormal6   = 3098, // CG_BINDLOCATION_MACRO(Normal6,CG_NORMAL6,"NORMAL6",3098,0,cgConnectorMemberParam)
    cgBindNormal7   = 3099, // CG_BINDLOCATION_MACRO(Normal7,CG_NORMAL7,"NORMAL7",3099,0,cgConnectorMemberParam)
    cgBindNormal8   = 3100, // CG_BINDLOCATION_MACRO(Normal8,CG_NORMAL8,"NORMAL8",3100,0,cgConnectorMemberParam)
    cgBindNormal9   = 3101, // CG_BINDLOCATION_MACRO(Normal9,CG_NORMAL9,"NORMAL9",3101,0,cgConnectorMemberParam)
    cgBindNormal10  = 3102, // CG_BINDLOCATION_MACRO(Normal10,CG_NORMAL10,"NORMAL10",3102,0,cgConnectorMemberParam)
    cgBindNormal11  = 3103, // CG_BINDLOCATION_MACRO(Normal11,CG_NORMAL11,"NORMAL11",3103,0,cgConnectorMemberParam)
    cgBindNormal12  = 3104, // CG_BINDLOCATION_MACRO(Normal12,CG_NORMAL12,"NORMAL12",3104,0,cgConnectorMemberParam)
    cgBindNormal13  = 3105, // CG_BINDLOCATION_MACRO(Normal13,CG_NORMAL13,"NORMAL13",3105,0,cgConnectorMemberParam)
    cgBindNormal14  = 3106, // CG_BINDLOCATION_MACRO(Normal14,CG_NORMAL14,"NORMAL14",3106,0,cgConnectorMemberParam)
    cgBindNormal15  = 3107, // CG_BINDLOCATION_MACRO(Normal15,CG_NORMAL15,"NORMAL15",3107,0,cgConnectorMemberParam)
    cgBindFogCoord  = 3156, // CCG_BINDLOCATION_MACRO(FogCoord,CG_FOGCOORD,"FOGCOORD",3156,0,cgConnectorMemberParam)
    cgBindTexCoord0 = 3220, // CG_BINDLOCATION_MACRO(TexCoord0,CG_TEXCOORD0,"TEXCOORD0",3220,0,cgConnectorMemberParam)
    cgBindTexCoord1 = 3221, // CG_BINDLOCATION_MACRO(TexCoord1,CG_TEXCOORD1,"TEXCOORD1",3221,0,cgConnectorMemberParam)
    cgBindTexCoord2 = 3222, // CG_BINDLOCATION_MACRO(TexCoord2,CG_TEXCOORD2,"TEXCOORD2",3222,0,cgConnectorMemberParam)
    cgBindTexCoord3 = 3223, // CG_BINDLOCATION_MACRO(TexCoord3,CG_TEXCOORD3,"TEXCOORD3",3223,0,cgConnectorMemberParam)
    cgBindTexCoord4 = 3224, // CG_BINDLOCATION_MACRO(TexCoord4,CG_TEXCOORD4,"TEXCOORD4",3224,0,cgConnectorMemberParam)
    cgBindTexCoord5 = 3225, // CG_BINDLOCATION_MACRO(TexCoord5,CG_TEXCOORD5,"TEXCOORD5",3225,0,cgConnectorMemberParam)
    cgBindTexCoord6 = 3226, // CG_BINDLOCATION_MACRO(TexCoord6,CG_TEXCOORD6,"TEXCOORD6",3226,0,cgConnectorMemberParam)
    cgBindTexCoord7 = 3227, // CG_BINDLOCATION_MACRO(TexCoord7,CG_TEXCOORD7,"TEXCOORD7",3227,0,cgConnectorMemberParam)
    cgBindTexCoord8 = 3228, // CG_BINDLOCATION_MACRO(TexCoord8,CG_TEXCOORD8,"TEXCOORD8",3228,0,cgConnectorMemberParam)
    cgBindTexCoord9 = 3229, // CG_BINDLOCATION_MACRO(TexCoord9,CG_TEXCOORD9,"TEXCOORD9",3229,0,cgConnectorMemberParam)
    cgBindTexCoord10= 3230, // CG_BINDLOCATION_MACRO(TexCoord10,CG_TEXCOORD10,"TEXCOORD10",3230,0,cgConnectorMemberParam)
    cgBindTexCoord11= 3231, // CG_BINDLOCATION_MACRO(TexCoord11,CG_TEXCOORD11,"TEXCOORD11",3231,0,cgConnectorMemberParam)
    cgBindTexCoord12= 3232, // CG_BINDLOCATION_MACRO(TexCoord12,CG_TEXCOORD12,"TEXCOORD12",3232,0,cgConnectorMemberParam)
    cgBindTexCoord13= 3233, // CG_BINDLOCATION_MACRO(TexCoord13,CG_TEXCOORD13,"TEXCOORD13",3233,0,cgConnectorMemberParam)
    cgBindTexCoord14= 3234, // CG_BINDLOCATION_MACRO(TexCoord14,CG_TEXCOORD14,"TEXCOORD14",3234,0,cgConnectorMemberParam)
    cgBindTexCoord15= 3235, // CG_BINDLOCATION_MACRO(TexCoord15,CG_TEXCOORD15,"TEXCOORD15",3235,0,cgConnectorMemberParam)
    cgBindCombinerConst0 = 3284, // CG_BINDLOCATION_MACRO(CombinerConst0,CG_COMBINER_CONST0,"COMBINER_CONST0",3284,0,cgUniformParam)
    cgBindCombinerConst1 = 3285, // CG_BINDLOCATION_MACRO(CombinerConst1,CG_COMBINER_CONST1,"COMBINER_CONST1",3285,0,cgUniformParam)
    cgBindCombinerStageConst0 = 3286, // CG_BINDLOCATION_MACRO(CombinerStageConst0,CG_COMBINER_STAGE_CONST0,"COMBINER_STAGE_CONST0",3286,1,cgUniformParam)
    cgBindCombinerStageConst1 = 3287, // CG_BINDLOCATION_MACRO(CombinerStageConst1,CG_COMBINER_STAGE_CONST1,"COMBINER_STAGE_CONST1",3287,1,cgUniformParam)
    cgBindOffsetTextureMatrix = 3288, // CG_BINDLOCATION_MACRO(OffsetTextureMatrix,CG_OFFSET_TEXTURE_MATRIX,"OFFSET_TEXTURE_MATRIX",3288,0,cgUniformParam)
    cgBindOffsetTextureScale  = 3289, // CG_BINDLOCATION_MACRO(OffsetTextureScale,CG_OFFSET_TEXTURE_SCALE,"OFFSET_TEXTURE_SCALE",3289,0,cgUniformParam)
    cgBindOffsetTextureBias   = 3290, // CG_BINDLOCATION_MACRO(OffsetTextureBias,CG_OFFSET_TEXTURE_BIAS,"OFFSET_TEXTURE_BIAS",3290,0,cgUniformParam)
    cgBindConstEye  = 3291, // CG_BINDLOCATION_MACRO(ConstEye,CG_CONST_EYE,"CONST_EYE",3291,0,cgUniformParam)
    cgBindTessFactor= 3255, // CG_BINDLOCATION_MACRO(TessFactor,CG_TESSFACTOR,"TESSFACTOR",3255,0,cgConnectorMemberParam)

    cgBindPosition    = cgBindPosition0,
    cgBindNormal      = cgBindNormal0,
    cgBindCol         = cgBindCol0,
    cgBindColor       = cgBindColor0,
    cgBindBlendWeight = cgBindBlendWeight0
  {$ENDIF}
  );
{$ELSE}
const
  cgBindTexUnit0  = 2048; // CG_BINDLOCATION_MACRO(TexUnit0,CG_TEXUNIT0,"texunit 0",2048,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit0}
  cgBindTexUnit1  = 2049; // CG_BINDLOCATION_MACRO(TexUnit1,CG_TEXUNIT1,"texunit 1",2049,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit1}
  cgBindTexUnit2  = 2050; // CG_BINDLOCATION_MACRO(TexUnit2,CG_TEXUNIT2,"texunit 2",2050,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit2}
  cgBindTexUnit3  = 2051; // CG_BINDLOCATION_MACRO(TexUnit3,CG_TEXUNIT3,"texunit 3",2051,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit3}
  cgBindTexUnit4  = 2052; // CG_BINDLOCATION_MACRO(TexUnit4,CG_TEXUNIT4,"texunit 4",2052,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit4}
  cgBindTexUnit5  = 2053; // CG_BINDLOCATION_MACRO(TexUnit5,CG_TEXUNIT5,"texunit 5",2053,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit5}
  cgBindTexUnit6  = 2054; // CG_BINDLOCATION_MACRO(TexUnit6,CG_TEXUNIT6,"texunit 6",2054,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit6}
  cgBindTexUnit7  = 2055; // CG_BINDLOCATION_MACRO(TexUnit7,CG_TEXUNIT7,"texunit 7",2055,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit7}
  cgBindTexUnit8  = 2056; // CG_BINDLOCATION_MACRO(TexUnit8,CG_TEXUNIT8,"texunit 8",2056,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit8}
  cgBindTexUnit9  = 2057; // CG_BINDLOCATION_MACRO(TexUnit9,CG_TEXUNIT9,"texunit 9",2057,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit9}
  cgBindTexUnit10 = 2058; // CG_BINDLOCATION_MACRO(TexUnit10,CG_TEXUNIT10,"texunit 10",2058,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit10}
  cgBindTexUnit11 = 2059; // CG_BINDLOCATION_MACRO(TexUnit11,CG_TEXUNIT11,"texunit 11",2059,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit11}
  cgBindTexUnit12 = 2060; // CG_BINDLOCATION_MACRO(TexUnit12,CG_TEXUNIT12,"texunit 12",2060,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit12}
  cgBindTexUnit13 = 2061; // CG_BINDLOCATION_MACRO(TexUnit13,CG_TEXUNIT13,"texunit 13",2061,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit13}
  cgBindTexUnit14 = 2062; // CG_BINDLOCATION_MACRO(TexUnit14,CG_TEXUNIT14,"texunit 14",2062,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit14}
  cgBindTexUnit15 = 2063; // CG_BINDLOCATION_MACRO(TexUnit15,CG_TEXUNIT15,"texunit 15",2063,0,cgTexObjParam)
  {$EXTERNALSYM cgBindTexUnit15}

  cgBindAttr0     = 2113; // CG_BINDLOCATION_MACRO(Attr0,CG_ATTR0,"ATTR0",2113,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr0}
  cgBindAttr1     = 2114; // CCG_BINDLOCATION_MACRO(Attr1,CG_ATTR1,"ATTR1",2114,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr1}
  cgBindAttr2     = 2115; // CCG_BINDLOCATION_MACRO(Attr2,CG_ATTR2,"ATTR2",2115,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr2}
  cgBindAttr3     = 2116; // CCG_BINDLOCATION_MACRO(Attr3,CG_ATTR3,"ATTR3",2116,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr3}
  cgBindAttr4     = 2117; // CCG_BINDLOCATION_MACRO(Attr4,CG_ATTR4,"ATTR4",2117,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr4}
  cgBindAttr5     = 2118; // CCG_BINDLOCATION_MACRO(Attr5,CG_ATTR5,"ATTR5",2118,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr5}
  cgBindAttr6     = 2119; // CCG_BINDLOCATION_MACRO(Attr6,CG_ATTR6,"ATTR6",2119,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr6}
  cgBindAttr7     = 2120; // CCG_BINDLOCATION_MACRO(Attr7,CG_ATTR7,"ATTR7",2120,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr7}
  cgBindAttr8     = 2121; // CCG_BINDLOCATION_MACRO(Attr8,CG_ATTR8,"ATTR8",2121,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr8}
  cgBindAttr9     = 2122; // CCG_BINDLOCATION_MACRO(Attr9,CG_ATTR9,"ATTR9",2122,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr9}
  cgBindAttr10    = 2123; // CCG_BINDLOCATION_MACRO(Attr10,CG_ATTR10,"ATTR10",2123,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr10}
  cgBindAttr11    = 2124; // CCG_BINDLOCATION_MACRO(Attr11,CG_ATTR11,"ATTR11",2124,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr11}
  cgBindAttr12    = 2125; // CCG_BINDLOCATION_MACRO(Attr12,CG_ATTR12,"ATTR12",2125,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr12}
  cgBindAttr13    = 2126; // CCG_BINDLOCATION_MACRO(Attr13,CG_ATTR13,"ATTR13",2126,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr13}
  cgBindAttr14    = 2127; // CCG_BINDLOCATION_MACRO(Attr14,CG_ATTR14,"ATTR14",2127,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr14}
  cgBindAttr15    = 2128; // CCG_BINDLOCATION_MACRO(Attr15,CG_ATTR15,"ATTR15",2128,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindAttr15}

  cgBindVertUniform = 2178; // CCG_BINDLOCATION_MACRO(VertUniform,CG_C,"c",2178,1,cgUniformParam)
  {$EXTERNALSYM cgBindVertUniform}

  cgBindTex0      = 2179; // CG_BINDLOCATION_MACRO(Tex0,CG_TEX0,"TEX0",2179,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex0}
  cgBindTex1      = 2180; // CG_BINDLOCATION_MACRO(Tex1,CG_TEX1,"TEX1",2180,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex1}
  cgBindTex2      = 2181; // CG_BINDLOCATION_MACRO(Tex2,CG_TEX2,"TEX2",2181,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex2}
  cgBindTex3      = 2192; // CG_BINDLOCATION_MACRO(Tex3,CG_TEX3,"TEX3",2192,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex3}
  cgBindTex4      = 2193; // CG_BINDLOCATION_MACRO(Tex4,CG_TEX4,"TEX4",2193,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex4}
  cgBindTex5      = 2194; // CG_BINDLOCATION_MACRO(Tex5,CG_TEX5,"TEX5",2194,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex5}
  cgBindTex6      = 2195; // CG_BINDLOCATION_MACRO(Tex6,CG_TEX6,"TEX6",2195,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex6}
  cgBindTex7      = 2196; // CG_BINDLOCATION_MACRO(Tex7,CG_TEX7,"TEX7",2196,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTex7}

  cgBindHPos      = 2243; // CG_BINDLOCATION_MACRO(HPos,CG_HPOS,"HPOS",2243,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindHPos}
  cgBindCol0      = 2245; // CG_BINDLOCATION_MACRO(Col0,CG_COL0,"COL0",2245,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindCol0}
  cgBindCol1      = 2246; // CG_BINDLOCATION_MACRO(Col1,CG_COL1,"COL1",2246,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindCol1}
  cgBindCol2      = 2247; // CG_BINDLOCATION_MACRO(Col2,CG_COL2,"COL2",2247,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindCol2}
  cgBindCol3      = 2248; // CG_BINDLOCATION_MACRO(Col3,CG_COL3,"COL3",2248,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindCol3}
  cgBindPSiz      = 2309; // CG_BINDLOCATION_MACRO(PSiz,CG_PSIZ,"PSIZ",2309,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSiz}
  cgBindWPos      = 2373; // CG_BINDLOCATION_MACRO(WPos,CG_WPOS,"WPOS",2373,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindWPos}

  cgBindPosition0 = 2437; // CG_BINDLOCATION_MACRO(Position0,CG_POSITION0,"POSITION0",2437,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition0}
  cgBindPosition1 = 2438; // CG_BINDLOCATION_MACRO(Position1,CG_POSITION1,"POSITION1",2438,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition1}
  cgBindPosition2 = 2439; // CG_BINDLOCATION_MACRO(Position2,CG_POSITION2,"POSITION2",2439,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition2}
  cgBindPosition3 = 2440; // CG_BINDLOCATION_MACRO(Position3,CG_POSITION3,"POSITION3",2440,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition3}
  cgBindPosition4 = 2441; // CG_BINDLOCATION_MACRO(Position4,CG_POSITION4,"POSITION4",2441,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition4}
  cgBindPosition5 = 2442; // CG_BINDLOCATION_MACRO(Position5,CG_POSITION5,"POSITION5",2442,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition5}
  cgBindPosition6 = 2443; // CG_BINDLOCATION_MACRO(Position6,CG_POSITION6,"POSITION6",2443,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition6}
  cgBindPosition7 = 2444; // CG_BINDLOCATION_MACRO(Position7,CG_POSITION7,"POSITION7",2444,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition7}
  cgBindPosition8 = 2445; // CG_BINDLOCATION_MACRO(Position8,CG_POSITION8,"POSITION8",2445,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition8}
  cgBindPosition9 = 2446; // CG_BINDLOCATION_MACRO(Position9,CG_POSITION9,"POSITION9",2446,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition9}
  cgBindPosition10= 2447; // CG_BINDLOCATION_MACRO(Position10,CG_POSITION10,"POSITION10",2447,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition10}
  cgBindPosition11= 2448; // CG_BINDLOCATION_MACRO(Position11,CG_POSITION11,"POSITION11",2448,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition11}
  cgBindPosition12= 2449; // CG_BINDLOCATION_MACRO(Position12,CG_POSITION12,"POSITION12",2449,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition12}
  cgBindPosition13= 2450; // CG_BINDLOCATION_MACRO(Position13,CG_POSITION13,"POSITION13",2450,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition13}
  cgBindPosition14= 2451; // CG_BINDLOCATION_MACRO(Position14,CG_POSITION14,"POSITION14",2451,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition14}
  cgBindPosition15= 2452; // CG_BINDLOCATION_MACRO(Position15,CG_POSITION15,"POSITION15",2452,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPosition15}
  cgBindDiffuse0  = 2501; // CG_BINDLOCATION_MACRO(Diffuse0,CG_DIFFUSE0,"DIFFUSE0",2501,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDiffuse0}
  cgBindTangent0  = 2565; // CG_BINDLOCATION_MACRO(Tangent0,CG_TANGENT0,"TANGENT0",2565,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent0}
  cgBindTangent1  = 2566; // CG_BINDLOCATION_MACRO(Tangent1,CG_TANGENT1,"TANGENT1",2566,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent1}
  cgBindTangent2  = 2567; // CG_BINDLOCATION_MACRO(Tangent2,CG_TANGENT2,"TANGENT2",2567,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent2}
  cgBindTangent3  = 2568; // CG_BINDLOCATION_MACRO(Tangent3,CG_TANGENT3,"TANGENT3",2568,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent3}
  cgBindTangent4  = 2569; // CG_BINDLOCATION_MACRO(Tangent4,CG_TANGENT4,"TANGENT4",2569,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent4}
  cgBindTangent5  = 2570; // CG_BINDLOCATION_MACRO(Tangent5,CG_TANGENT5,"TANGENT5",2570,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent5}
  cgBindTangent6  = 2571; // CG_BINDLOCATION_MACRO(Tangent6,CG_TANGENT6,"TANGENT6",2571,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent6}
  cgBindTangent7  = 2572; // CG_BINDLOCATION_MACRO(Tangent7,CG_TANGENT7,"TANGENT7",2572,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent7}
  cgBindTangent8  = 2573; // CG_BINDLOCATION_MACRO(Tangent8,CG_TANGENT8,"TANGENT8",2573,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent8}
  cgBindTangent9  = 2574; // CG_BINDLOCATION_MACRO(Tangent9,CG_TANGENT9,"TANGENT9",2574,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent9}
  cgBindTangent10 = 2575; // CG_BINDLOCATION_MACRO(Tangent10,CG_TANGENT10,"TANGENT10",2575,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent10}
  cgBindTangent11 = 2576; // CG_BINDLOCATION_MACRO(Tangent11,CG_TANGENT11,"TANGENT11",2576,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent11}
  cgBindTangent12 = 2577; // CG_BINDLOCATION_MACRO(Tangent12,CG_TANGENT12,"TANGENT12",2577,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent12}
  cgBindTangent13 = 2578; // CG_BINDLOCATION_MACRO(Tangent13,CG_TANGENT13,"TANGENT13",2578,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent13}
  cgBindTangent14 = 2579; // CG_BINDLOCATION_MACRO(Tangent14,CG_TANGENT14,"TANGENT14",2579,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent14}
  cgBindTangent15 = 2580; // CG_BINDLOCATION_MACRO(Tangent15,CG_TANGENT15,"TANGENT15",2580,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTangent15}
  cgBindSpecular0 = 2629; // CG_BINDLOCATION_MACRO(Specular0,CG_SPECULAR0,"SPECULAR0",2629,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSpecular0}
  cgBindBlendIndices0 = 2693; // CG_BINDLOCATION_MACRO(BlendIndices0,CG_BLENDINDICES0,"BLENDINDICES0",2693,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices0}
  cgBindBlendIndices1 = 2694; // CG_BINDLOCATION_MACRO(BlendIndices1,CG_BLENDINDICES1,"BLENDINDICES1",2694,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices1}
  cgBindBlendIndices2 = 2695; // CG_BINDLOCATION_MACRO(BlendIndices2,CG_BLENDINDICES2,"BLENDINDICES2",2695,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices2}
  cgBindBlendIndices3 = 2696; // CG_BINDLOCATION_MACRO(BlendIndices3,CG_BLENDINDICES3,"BLENDINDICES3",2696,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices3}
  cgBindBlendIndices4 = 2697; // CG_BINDLOCATION_MACRO(BlendIndices4,CG_BLENDINDICES4,"BLENDINDICES4",2697,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices4}
  cgBindBlendIndices5 = 2698; // CG_BINDLOCATION_MACRO(BlendIndices5,CG_BLENDINDICES5,"BLENDINDICES5",2698,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices5}
  cgBindBlendIndices6 = 2699; // CG_BINDLOCATION_MACRO(BlendIndices6,CG_BLENDINDICES6,"BLENDINDICES6",2699,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices6}
  cgBindBlendIndices7 = 2700; // CG_BINDLOCATION_MACRO(BlendIndices7,CG_BLENDINDICES7,"BLENDINDICES7",2700,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices7}
  cgBindBlendIndices8 = 2701; // CG_BINDLOCATION_MACRO(BlendIndices8,CG_BLENDINDICES8,"BLENDINDICES8",2701,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices8}
  cgBindBlendIndices9 = 2702; // CG_BINDLOCATION_MACRO(BlendIndices9,CG_BLENDINDICES9,"BLENDINDICES9",2702,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices9}
  cgBindBlendIndices10 = 2703; // CG_BINDLOCATION_MACRO(BlendIndices10,CG_BLENDINDICES10,"BLENDINDICES10",2703,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices10}
  cgBindBlendIndices11 = 2704; // CG_BINDLOCATION_MACRO(BlendIndices11,CG_BLENDINDICES11,"BLENDINDICES11",2704,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices11}
  cgBindBlendIndices12 = 2705; // CG_BINDLOCATION_MACRO(BlendIndices12,CG_BLENDINDICES12,"BLENDINDICES12",2705,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices12}
  cgBindBlendIndices13 = 2706; // CG_BINDLOCATION_MACRO(BlendIndices13,CG_BLENDINDICES13,"BLENDINDICES13",2706,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices13}
  cgBindBlendIndices14 = 2707; // CG_BINDLOCATION_MACRO(BlendIndices14,CG_BLENDINDICES14,"BLENDINDICES14",2707,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices14}
  cgBindBlendIndices15 = 2708; // CG_BINDLOCATION_MACRO(BlendIndices15,CG_BLENDINDICES15,"BLENDINDICES15",2708,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendIndices15}
  cgBindColor0    = 2757; // CG_BINDLOCATION_MACRO(Color0,CG_COLOR0,"COLOR0",2757,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor0}
  cgBindColor1    = 2758; // CG_BINDLOCATION_MACRO(Color1,CG_COLOR1,"COLOR1",2758,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor1}
  cgBindColor2    = 2759; // CG_BINDLOCATION_MACRO(Color2,CG_COLOR2,"COLOR2",2759,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor2}
  cgBindColor3    = 2760; // CG_BINDLOCATION_MACRO(Color3,CG_COLOR3,"COLOR3",2760,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor3}
  cgBindColor4    = 2761; // CG_BINDLOCATION_MACRO(Color4,CG_COLOR4,"COLOR4",2761,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor4}
  cgBindColor5    = 2762; // CG_BINDLOCATION_MACRO(Color5,CG_COLOR5,"COLOR5",2762,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor5}
  cgBindColor6    = 2763; // CG_BINDLOCATION_MACRO(Color6,CG_COLOR6,"COLOR6",2763,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor6}
  cgBindColor7    = 2764; // CG_BINDLOCATION_MACRO(Color7,CG_COLOR7,"COLOR7",2764,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor7}
  cgBindColor8    = 2765; // CG_BINDLOCATION_MACRO(Color8,CG_COLOR8,"COLOR8",2765,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor8}
  cgBindColor9    = 2766; // CG_BINDLOCATION_MACRO(Color9,CG_COLOR9,"COLOR9",2766,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor9}
  cgBindColor10   = 2767; // CG_BINDLOCATION_MACRO(Color10,CG_COLOR10,"COLOR10",2767,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor10}
  cgBindColor11   = 2768; // CG_BINDLOCATION_MACRO(Color11,CG_COLOR11,"COLOR11",2768,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor11}
  cgBindColor12   = 2769; // CG_BINDLOCATION_MACRO(Color12,CG_COLOR12,"COLOR12",2769,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor12}
  cgBindColor13   = 2770; // CG_BINDLOCATION_MACRO(Color13,CG_COLOR13,"COLOR13",2770,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor13}
  cgBindColor14   = 2771; // CG_BINDLOCATION_MACRO(Color14,CG_COLOR14,"COLOR14",2771,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor14}
  cgBindColor15   = 2772; // CG_BINDLOCATION_MACRO(Color15,CG_COLOR15,"COLOR15",2772,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindColor15}
  cgBindPSize0    = 2821; // CG_BINDLOCATION_MACRO(PSize0,CG_PSIZE0,"PSIZE0",2821,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize0}
  cgBindPSize1    = 2822; // CG_BINDLOCATION_MACRO(PSize1,CG_PSIZE1,"PSIZE1",2822,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize1}
  cgBindPSize2    = 2823; // CG_BINDLOCATION_MACRO(PSize2,CG_PSIZE2,"PSIZE2",2823,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize2}
  cgBindPSize3    = 2824; // CG_BINDLOCATION_MACRO(PSize3,CG_PSIZE3,"PSIZE3",2824,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize3}
  cgBindPSize4    = 2825; // CG_BINDLOCATION_MACRO(PSize4,CG_PSIZE4,"PSIZE4",2825,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize4}
  cgBindPSize5    = 2826; // CG_BINDLOCATION_MACRO(PSize5,CG_PSIZE5,"PSIZE5",2826,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize5}
  cgBindPSize6    = 2827; // CG_BINDLOCATION_MACRO(PSize6,CG_PSIZE6,"PSIZE6",2827,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize6}
  cgBindPSize7    = 2828; // CG_BINDLOCATION_MACRO(PSize7,CG_PSIZE7,"PSIZE7",2828,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize7}
  cgBindPSize8    = 2829; // CG_BINDLOCATION_MACRO(PSize8,CG_PSIZE8,"PSIZE8",2829,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize8}
  cgBindPSize9    = 2830; // CG_BINDLOCATION_MACRO(PSize9,CG_PSIZE9,"PSIZE9",2830,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize9}
  cgBindPSize10   = 2831; // CG_BINDLOCATION_MACRO(PSize10,CG_PSIZE10,"PSIZE10",2831,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize10}
  cgBindPSize11   = 2832; // CG_BINDLOCATION_MACRO(PSize11,CG_PSIZE11,"PSIZE11",2832,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize11}
  cgBindPSize12   = 2833; // CG_BINDLOCATION_MACRO(PSize12,CG_PSIZE12,"PSIZE12",2833,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize12}
  cgBindPSize13   = 2834; // CG_BINDLOCATION_MACRO(PSize13,CG_PSIZE13,"PSIZE13",2834,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize13}
  cgBindPSize14   = 2835; // CG_BINDLOCATION_MACRO(PSize14,CG_PSIZE14,"PSIZE14",2835,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize14}
  cgBindPSize15   = 2836; // CG_BINDLOCATION_MACRO(PSize15,CG_PSIZE15,"PSIZE15",2836,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindPSize15}
  cgBindBiNormal0 = 2885; // CG_BINDLOCATION_MACRO(BiNormal0,CG_BINORMAL0,"BINORMAL0",2885,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal0}
  cgBindBiNormal1 = 2886; // CG_BINDLOCATION_MACRO(BiNormal1,CG_BINORMAL1,"BINORMAL1",2886,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal1}
  cgBindBiNormal2 = 2887; // CG_BINDLOCATION_MACRO(BiNormal2,CG_BINORMAL2,"BINORMAL2",2887,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal2}
  cgBindBiNormal3 = 2888; // CG_BINDLOCATION_MACRO(BiNormal3,CG_BINORMAL3,"BINORMAL3",2888,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal3}
  cgBindBiNormal4 = 2889; // CG_BINDLOCATION_MACRO(BiNormal4,CG_BINORMAL4,"BINORMAL4",2889,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal4}
  cgBindBiNormal5 = 2890; // CG_BINDLOCATION_MACRO(BiNormal5,CG_BINORMAL5,"BINORMAL5",2890,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal5}
  cgBindBiNormal6 = 2891; // CG_BINDLOCATION_MACRO(BiNormal6,CG_BINORMAL6,"BINORMAL6",2891,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal6}
  cgBindBiNormal7 = 2892; // CG_BINDLOCATION_MACRO(BiNormal7,CG_BINORMAL7,"BINORMAL7",2892,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal7}
  cgBindBiNormal8 = 2893; // CG_BINDLOCATION_MACRO(BiNormal8,CG_BINORMAL8,"BINORMAL8",2893,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal8}
  cgBindBiNormal9 = 2894; // CG_BINDLOCATION_MACRO(BiNormal9,CG_BINORMAL9,"BINORMAL9",2894,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal9}
  cgBindBiNormal10= 2895; // CG_BINDLOCATION_MACRO(BiNormal10,CG_BINORMAL10,"BINORMAL10",2895,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal10}
  cgBindBiNormal11= 2896; // CG_BINDLOCATION_MACRO(BiNormal11,CG_BINORMAL11,"BINORMAL11",2896,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal11}
  cgBindBiNormal12= 2897; // CG_BINDLOCATION_MACRO(BiNormal12,CG_BINORMAL12,"BINORMAL12",2897,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal12}
  cgBindBiNormal13= 2898; // CG_BINDLOCATION_MACRO(BiNormal13,CG_BINORMAL13,"BINORMAL13",2898,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal13}
  cgBindBiNormal14= 2899; // CG_BINDLOCATION_MACRO(BiNormal14,CG_BINORMAL14,"BINORMAL14",2899,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal14}
  cgBindBiNormal15= 2900; // CG_BINDLOCATION_MACRO(BiNormal15,CG_BINORMAL15,"BINORMAL15",2900,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBiNormal15}
  cgBindFOG0      = 2917; // CG_BINDLOCATION_MACRO(FOG0,CG_FOG0,"FOG0",2917,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG0}
  cgBindFOG1      = 2918; // CG_BINDLOCATION_MACRO(FOG1,CG_FOG1,"FOG1",2918,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG1}
  cgBindFOG2      = 2919; // CG_BINDLOCATION_MACRO(FOG2,CG_FOG2,"FOG2",2919,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG2}
  cgBindFOG3      = 2920; // CG_BINDLOCATION_MACRO(FOG3,CG_FOG3,"FOG3",2920,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG3}
  cgBindFOG4      = 2921; // CG_BINDLOCATION_MACRO(FOG4,CG_FOG4,"FOG4",2921,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG4}
  cgBindFOG5      = 2922; // CG_BINDLOCATION_MACRO(FOG5,CG_FOG5,"FOG5",2922,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG5}
  cgBindFOG6      = 2923; // CG_BINDLOCATION_MACRO(FOG6,CG_FOG6,"FOG6",2923,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG6}
  cgBindFOG7      = 2924; // CG_BINDLOCATION_MACRO(FOG7,CG_FOG7,"FOG7",2924,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG7}
  cgBindFOG8      = 2925; // CG_BINDLOCATION_MACRO(FOG8,CG_FOG8,"FOG8",2925,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG8}
  cgBindFOG9      = 2926; // CG_BINDLOCATION_MACRO(FOG9,CG_FOG9,"FOG9",2926,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG9}
  cgBindFOG10     = 2927; // CG_BINDLOCATION_MACRO(FOG10,CG_FOG10,"FOG10",2927,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG10}
  cgBindFOG11     = 2928; // CG_BINDLOCATION_MACRO(FOG11,CG_FOG11,"FOG11",2928,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG11}
  cgBindFOG12     = 2929; // CG_BINDLOCATION_MACRO(FOG12,CG_FOG12,"FOG12",2929,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG12}
  cgBindFOG13     = 2930; // CG_BINDLOCATION_MACRO(FOG13,CG_FOG13,"FOG13",2930,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG13}
  cgBindFOG14     = 2931; // CG_BINDLOCATION_MACRO(FOG14,CG_FOG14,"FOG14",2931,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG14}
  cgBindFOG15     = 2932; // CG_BINDLOCATION_MACRO(FOG15,CG_FOG15,"FOG15",2932,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFOG15}
  cgBindDEPTH0    = 2933; // CG_BINDLOCATION_MACRO(DEPTH0,CG_DEPTH0,"DEPTH0",2933,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH0}
  cgBindDEPTH1    = 2934; // CG_BINDLOCATION_MACRO(DEPTH1,CG_DEPTH1,"DEPTH1",2934,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH1}
  cgBindDEPTH2    = 2935; // CG_BINDLOCATION_MACRO(DEPTH2,CG_DEPTH2,"DEPTH2",2935,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH2}
  cgBindDEPTH3    = 2936; // CG_BINDLOCATION_MACRO(DEPTH3,CG_DEPTH3,"DEPTH3",2936,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH3}
  cgBindDEPTH4    = 2937; // CG_BINDLOCATION_MACRO(DEPTH4,CG_DEPTH4,"DEPTH4",2937,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH4}
  cgBindDEPTH5    = 2938; // CG_BINDLOCATION_MACRO(DEPTH5,CG_DEPTH5,"DEPTH5",2938,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH5}
  cgBindDEPTH6    = 2939; // CG_BINDLOCATION_MACRO(DEPTH6,CG_DEPTH6,"DEPTH6",2939,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH6}
  cgBindDEPTH7    = 2940; // CG_BINDLOCATION_MACRO(DEPTH7,CG_DEPTH7,"DEPTH7",2940,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH7}
  cgBindDEPTH8    = 2941; // CG_BINDLOCATION_MACRO(DEPTH8,CG_DEPTH8,"DEPTH8",2941,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH8}
  cgBindDEPTH9    = 29542; // CG_BINDLOCATION_MACRO(DEPTH9,CG_DEPTH9,"DEPTH9",29542,0,cgConnectorMemberParam) //todo: What the @#$% !!!
  {$EXTERNALSYM cgBindDEPTH9}
  cgBindDEPTH10   = 2943; // CG_BINDLOCATION_MACRO(DEPTH10,CG_DEPTH10,"DEPTH10",2943,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH10}
  cgBindDEPTH11   = 2944; // CG_BINDLOCATION_MACRO(DEPTH11,CG_DEPTH11,"DEPTH11",2944,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH11}
  cgBindDEPTH12   = 2945; // CG_BINDLOCATION_MACRO(DEPTH12,CG_DEPTH12,"DEPTH12",2945,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH12}
  cgBindDEPTH13   = 2946; // CG_BINDLOCATION_MACRO(DEPTH13,CG_DEPTH13,"DEPTH13",2946,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH13}
  cgBindDEPTH14   = 2947; // CG_BINDLOCATION_MACRO(DEPTH14,CG_DEPTH14,"DEPTH14",2947,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH14}
  cgBindDEPTH15   = 2948; // CG_BINDLOCATION_MACRO(DEPTH15,CG_DEPTH15,"DEPTH15",2948,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindDEPTH15}
  cgBindSAMPLE0   = 2949; // CG_BINDLOCATION_MACRO(SAMPLE0,CG_SAMPLE0,"SAMPLE0",2949,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE0}
  cgBindSAMPLE1   = 2950; // CG_BINDLOCATION_MACRO(SAMPLE1,CG_SAMPLE1,"SAMPLE1",2950,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE1}
  cgBindSAMPLE2   = 2951; // CG_BINDLOCATION_MACRO(SAMPLE2,CG_SAMPLE2,"SAMPLE2",2951,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE2}
  cgBindSAMPLE3   = 2952; // CG_BINDLOCATION_MACRO(SAMPLE3,CG_SAMPLE3,"SAMPLE3",2952,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE3}
  cgBindSAMPLE4   = 2953; // CG_BINDLOCATION_MACRO(SAMPLE4,CG_SAMPLE4,"SAMPLE4",2953,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE4}
  cgBindSAMPLE5   = 2954; // CG_BINDLOCATION_MACRO(SAMPLE5,CG_SAMPLE5,"SAMPLE5",2954,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE5}
  cgBindSAMPLE6   = 2955; // CG_BINDLOCATION_MACRO(SAMPLE6,CG_SAMPLE6,"SAMPLE6",2955,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE6}
  cgBindSAMPLE7   = 2956; // CG_BINDLOCATION_MACRO(SAMPLE7,CG_SAMPLE7,"SAMPLE7",2956,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE7}
  cgBindSAMPLE8   = 2957; // CG_BINDLOCATION_MACRO(SAMPLE8,CG_SAMPLE8,"SAMPLE8",2957,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE8}
  cgBindSAMPLE9   = 2958; // CG_BINDLOCATION_MACRO(SAMPLE9,CG_SAMPLE9,"SAMPLE9",2958,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE9}
  cgBindSAMPLE10  = 2959; // CG_BINDLOCATION_MACRO(SAMPLE10,CG_SAMPLE10,"SAMPLE10",2959,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE10}
  cgBindSAMPLE11  = 2960; // CG_BINDLOCATION_MACRO(SAMPLE11,CG_SAMPLE11,"SAMPLE11",2960,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE11}
  cgBindSAMPLE12  = 2961; // CG_BINDLOCATION_MACRO(SAMPLE12,CG_SAMPLE12,"SAMPLE12",2961,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE12}
  cgBindSAMPLE13  = 2962; // CG_BINDLOCATION_MACRO(SAMPLE13,CG_SAMPLE13,"SAMPLE13",2962,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE13}
  cgBindSAMPLE14  = 2963; // CG_BINDLOCATION_MACRO(SAMPLE14,CG_SAMPLE14,"SAMPLE14",2963,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE14}
  cgBindSAMPLE15  = 2964; // CG_BINDLOCATION_MACRO(SAMPLE15,CG_SAMPLE15,"SAMPLE15",2964,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindSAMPLE15}
  cgBindBlendWeight0 = 3028; // CG_BINDLOCATION_MACRO(BlendWeight0,CG_BLENDWEIGHT0,"BLENDWEIGHT0",3028,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight0}
  cgBindBlendWeight1 = 3029; // CG_BINDLOCATION_MACRO(BlendWeight1,CG_BLENDWEIGHT1,"BLENDWEIGHT1",3029,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight1}
  cgBindBlendWeight2 = 3030; // CG_BINDLOCATION_MACRO(BlendWeight2,CG_BLENDWEIGHT2,"BLENDWEIGHT2",3030,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight2}
  cgBindBlendWeight3 = 3031; // CG_BINDLOCATION_MACRO(BlendWeight3,CG_BLENDWEIGHT3,"BLENDWEIGHT3",3031,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight3}
  cgBindBlendWeight4 = 3032; // CG_BINDLOCATION_MACRO(BlendWeight4,CG_BLENDWEIGHT4,"BLENDWEIGHT4",3032,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight4}
  cgBindBlendWeight5 = 3033; // CG_BINDLOCATION_MACRO(BlendWeight5,CG_BLENDWEIGHT5,"BLENDWEIGHT5",3033,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight5}
  cgBindBlendWeight6 = 3034; // CG_BINDLOCATION_MACRO(BlendWeight6,CG_BLENDWEIGHT6,"BLENDWEIGHT6",3034,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight6}
  cgBindBlendWeight7 = 3035; // CG_BINDLOCATION_MACRO(BlendWeight7,CG_BLENDWEIGHT7,"BLENDWEIGHT7",3035,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight7}
  cgBindBlendWeight8 = 3036; // CG_BINDLOCATION_MACRO(BlendWeight8,CG_BLENDWEIGHT8,"BLENDWEIGHT8",3036,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight8}
  cgBindBlendWeight9 = 3037; // CG_BINDLOCATION_MACRO(BlendWeight9,CG_BLENDWEIGHT9,"BLENDWEIGHT9",3037,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight9}
  cgBindBlendWeight10= 3038; // CG_BINDLOCATION_MACRO(BlendWeight10,CG_BLENDWEIGHT10,"BLENDWEIGHT10",3038,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight10}
  cgBindBlendWeight11= 3039; // CG_BINDLOCATION_MACRO(BlendWeight11,CG_BLENDWEIGHT11,"BLENDWEIGHT11",3039,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight11}
  cgBindBlendWeight12= 3040; // CG_BINDLOCATION_MACRO(BlendWeight12,CG_BLENDWEIGHT12,"BLENDWEIGHT12",3040,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight12}
  cgBindBlendWeight13= 3041; // CG_BINDLOCATION_MACRO(BlendWeight13,CG_BLENDWEIGHT13,"BLENDWEIGHT13",3041,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight13}
  cgBindBlendWeight14= 3042; // CG_BINDLOCATION_MACRO(BlendWeight14,CG_BLENDWEIGHT14,"BLENDWEIGHT14",3042,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight14}
  cgBindBlendWeight15= 3043; // CG_BINDLOCATION_MACRO(BlendWeight15,CG_BLENDWEIGHT15,"BLENDWEIGHT15",3043,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindBlendWeight15}
  cgBindNormal0   = 3092; // CG_BINDLOCATION_MACRO(Normal0,CG_NORMAL0,"NORMAL0",3092,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal0}
  cgBindNormal1   = 3093; // CG_BINDLOCATION_MACRO(Normal1,CG_NORMAL1,"NORMAL1",3093,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal1}
  cgBindNormal2   = 3094; // CG_BINDLOCATION_MACRO(Normal2,CG_NORMAL2,"NORMAL2",3094,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal2}
  cgBindNormal3   = 3095; // CG_BINDLOCATION_MACRO(Normal3,CG_NORMAL3,"NORMAL3",3095,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal3}
  cgBindNormal4   = 3096; // CG_BINDLOCATION_MACRO(Normal4,CG_NORMAL4,"NORMAL4",3096,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal4}
  cgBindNormal5   = 3097; // CG_BINDLOCATION_MACRO(Normal5,CG_NORMAL5,"NORMAL5",3097,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal5}
  cgBindNormal6   = 3098; // CG_BINDLOCATION_MACRO(Normal6,CG_NORMAL6,"NORMAL6",3098,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal6}
  cgBindNormal7   = 3099; // CG_BINDLOCATION_MACRO(Normal7,CG_NORMAL7,"NORMAL7",3099,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal7}
  cgBindNormal8   = 3100; // CG_BINDLOCATION_MACRO(Normal8,CG_NORMAL8,"NORMAL8",3100,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal8}
  cgBindNormal9   = 3101; // CG_BINDLOCATION_MACRO(Normal9,CG_NORMAL9,"NORMAL9",3101,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal9}
  cgBindNormal10  = 3102; // CG_BINDLOCATION_MACRO(Normal10,CG_NORMAL10,"NORMAL10",3102,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal10}
  cgBindNormal11  = 3103; // CG_BINDLOCATION_MACRO(Normal11,CG_NORMAL11,"NORMAL11",3103,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal11}
  cgBindNormal12  = 3104; // CG_BINDLOCATION_MACRO(Normal12,CG_NORMAL12,"NORMAL12",3104,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal12}
  cgBindNormal13  = 3105; // CG_BINDLOCATION_MACRO(Normal13,CG_NORMAL13,"NORMAL13",3105,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal13}
  cgBindNormal14  = 3106; // CG_BINDLOCATION_MACRO(Normal14,CG_NORMAL14,"NORMAL14",3106,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal14}
  cgBindNormal15  = 3107; // CG_BINDLOCATION_MACRO(Normal15,CG_NORMAL15,"NORMAL15",3107,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindNormal15}
  cgBindFogCoord  = 3156; // CCG_BINDLOCATION_MACRO(FogCoord,CG_FOGCOORD,"FOGCOORD",3156,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindFogCoord}
  cgBindTexCoord0 = 3220; // CG_BINDLOCATION_MACRO(TexCoord0,CG_TEXCOORD0,"TEXCOORD0",3220,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord0}
  cgBindTexCoord1 = 3221; // CG_BINDLOCATION_MACRO(TexCoord1,CG_TEXCOORD1,"TEXCOORD1",3221,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord1}
  cgBindTexCoord2 = 3222; // CG_BINDLOCATION_MACRO(TexCoord2,CG_TEXCOORD2,"TEXCOORD2",3222,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord2}
  cgBindTexCoord3 = 3223; // CG_BINDLOCATION_MACRO(TexCoord3,CG_TEXCOORD3,"TEXCOORD3",3223,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord3}
  cgBindTexCoord4 = 3224; // CG_BINDLOCATION_MACRO(TexCoord4,CG_TEXCOORD4,"TEXCOORD4",3224,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord4}
  cgBindTexCoord5 = 3225; // CG_BINDLOCATION_MACRO(TexCoord5,CG_TEXCOORD5,"TEXCOORD5",3225,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord5}
  cgBindTexCoord6 = 3226; // CG_BINDLOCATION_MACRO(TexCoord6,CG_TEXCOORD6,"TEXCOORD6",3226,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord6}
  cgBindTexCoord7 = 3227; // CG_BINDLOCATION_MACRO(TexCoord7,CG_TEXCOORD7,"TEXCOORD7",3227,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord7}
  cgBindTexCoord8 = 3228; // CG_BINDLOCATION_MACRO(TexCoord8,CG_TEXCOORD8,"TEXCOORD8",3228,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord8}
  cgBindTexCoord9 = 3229; // CG_BINDLOCATION_MACRO(TexCoord9,CG_TEXCOORD9,"TEXCOORD9",3229,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord9}
  cgBindTexCoord10= 3230; // CG_BINDLOCATION_MACRO(TexCoord10,CG_TEXCOORD10,"TEXCOORD10",3230,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord10}
  cgBindTexCoord11= 3231; // CG_BINDLOCATION_MACRO(TexCoord11,CG_TEXCOORD11,"TEXCOORD11",3231,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord11}
  cgBindTexCoord12= 3232; // CG_BINDLOCATION_MACRO(TexCoord12,CG_TEXCOORD12,"TEXCOORD12",3232,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord12}
  cgBindTexCoord13= 3233; // CG_BINDLOCATION_MACRO(TexCoord13,CG_TEXCOORD13,"TEXCOORD13",3233,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord13}
  cgBindTexCoord14= 3234; // CG_BINDLOCATION_MACRO(TexCoord14,CG_TEXCOORD14,"TEXCOORD14",3234,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord14}
  cgBindTexCoord15= 3235; // CG_BINDLOCATION_MACRO(TexCoord15,CG_TEXCOORD15,"TEXCOORD15",3235,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTexCoord15}
  cgBindCombinerConst0 = 3284; // CG_BINDLOCATION_MACRO(CombinerConst0,CG_COMBINER_CONST0,"COMBINER_CONST0",3284,0,cgUniformParam)
  {$EXTERNALSYM cgBindCombinerConst0}
  cgBindCombinerConst1 = 3285; // CG_BINDLOCATION_MACRO(CombinerConst1,CG_COMBINER_CONST1,"COMBINER_CONST1",3285,0,cgUniformParam)
  {$EXTERNALSYM cgBindCombinerConst1}
  cgBindCombinerStageConst0 = 3286; // CG_BINDLOCATION_MACRO(CombinerStageConst0,CG_COMBINER_STAGE_CONST0,"COMBINER_STAGE_CONST0",3286,1,cgUniformParam)
  {$EXTERNALSYM cgBindCombinerStageConst0}
  cgBindCombinerStageConst1 = 3287; // CG_BINDLOCATION_MACRO(CombinerStageConst1,CG_COMBINER_STAGE_CONST1,"COMBINER_STAGE_CONST1",3287,1,cgUniformParam)
  {$EXTERNALSYM cgBindCombinerStageConst1}
  cgBindOffsetTextureMatrix = 3288; // CG_BINDLOCATION_MACRO(OffsetTextureMatrix,CG_OFFSET_TEXTURE_MATRIX,"OFFSET_TEXTURE_MATRIX",3288,0,cgUniformParam)
  {$EXTERNALSYM cgBindOffsetTextureMatrix}
  cgBindOffsetTextureScale  = 3289; // CG_BINDLOCATION_MACRO(OffsetTextureScale,CG_OFFSET_TEXTURE_SCALE,"OFFSET_TEXTURE_SCALE",3289,0,cgUniformParam)
  {$EXTERNALSYM cgBindOffsetTextureScale}
  cgBindOffsetTextureBias   = 3290; // CG_BINDLOCATION_MACRO(OffsetTextureBias,CG_OFFSET_TEXTURE_BIAS,"OFFSET_TEXTURE_BIAS",3290,0,cgUniformParam)
  {$EXTERNALSYM cgBindOffsetTextureBias}
  cgBindConstEye  = 3291; // CG_BINDLOCATION_MACRO(ConstEye,CG_CONST_EYE,"CONST_EYE",3291,0,cgUniformParam)
  {$EXTERNALSYM cgBindConstEye}
  cgBindTessFactor= 3255; // CG_BINDLOCATION_MACRO(TessFactor,CG_TESSFACTOR,"TESSFACTOR",3255,0,cgConnectorMemberParam)
  {$EXTERNALSYM cgBindTessFactor}

  cgBindPosition    = cgBindPosition0;
  {$EXTERNALSYM cgBindPosition}
  cgBindNormal      = cgBindNormal0;
  {$EXTERNALSYM cgBindNormal}
  cgBindCol         = cgBindCol0;
  {$EXTERNALSYM cgBindCol}
  cgBindColor       = cgBindColor0;
  {$EXTERNALSYM cgBindColor}
  cgBindBlendWeight = cgBindBlendWeight0;
  {$EXTERNALSYM cgBindBlendWeight}

type
  TcgBindLocation = DWORD;
{$ENDIF}
  cgBindLocation = TcgBindLocation;
  {$NODEFINE cgBindLocation}
  {$NODEFINE TcgBindLocation}
  {$HPPEMIT 'typedef cgBindLocation TcgBindLocation;'}


  (*
   * The following define the supported CG profiles.
   *
   *   CG_PROFILE_MACRO(name, compiler_id, compiler_opt)
   *
   *     name         : The name of the profile.  Used consistently with the API.
   *     compiler_id  : The identifier string for the profile used by the compiler.
   *     compiler_id_caps : compiler_id in caps.
   *     compiler_opt : The command-line switch used to force compilation into
   *                    the profile.
   *     int_id           : Integer enumerant associated with this bind location.
   *     vertex_profile   : Non-zero if this is a vertex profile, otherwise it
   *                        is considered to be a fragment profile.
   *
   *
   *)
{$IFDEF COMPILER6_UP}
  TcgProfileType = (
  {$IFDEF BCB}
    cgProfileDummy
  {$ELSE}
    cgProfileStart = 6144,

    CG_PROFILE_UNKNOWN,
    cgUnknownProfile = CG_PROFILE_UNKNOWN,

    //# define CG_PROFILE_MACRO(name, compiler_id, compiler_id_caps, compiler_opt,int_id,vertex_profile) \
    //   cg##name##Profile = int_id,

    cgVertexProfile        = 6146, // CG_PROFILE_MACRO(Vertex,vp20,VP20,"vp20",6146,1)
    cgFragment20Profile    = 6147, // CG_PROFILE_MACRO(Fragment20,fp20,FP20,"fp20",6147,0)
    cgVertex30Profile      = 6148, // CG_PROFILE_MACRO(Vertex30,vp30,VP30,"vp30",6148,1)
    cgFragmentProfile      = 6149, // CG_PROFILE_MACRO(Fragment,fp30,FP30,"fp30",6149,0)
    cgARBVertexProfile     = 6150, // CG_PROFILE_MACRO(ARBVertex,arbvp1,ARBVP1,"arbvp1",6150,1)
    cgARBFragmentProfile   = 7000, // CG_PROFILE_MACRO(ARBFragment,arbfp1,ARBFP1,"arbfp1",7000,0)

    cgDX9Vertex11Profile   = 6153, // CG_PROFILE_MACRO(DX9Vertex11,vs_1_1,VS_1_1,"vs_1_1",6153,1)
    cgDX9Vertex20Profile   = 6154, // CG_PROFILE_MACRO(DX9Vertex20,vs_2_0,VS_2_0,"vs_2_0",6154,1)
    cgDX9Vertex2xProfile   = 6155, // CG_PROFILE_MACRO(DX9Vertex2x,vs_2_x,VS_2_X,"vs_2_x",6155,1)

    cgDX9Pixel11Profile    = 6159, // CG_PROFILE_MACRO(DX9Pixel11,ps_1_1,PS_1_1,"ps_1_1",6159,0)
    cgDX9Pixel12Profile    = 6160, // CG_PROFILE_MACRO(DX9Pixel12,ps_1_2,PS_1_2,"ps_1_2",6160,0)
    cgDX9Pixel13Profile    = 6161, // CG_PROFILE_MACRO(DX9Pixel13,ps_1_3,PS_1_3,"ps_1_3",6161,0)
    cgDX9Pixel20Profile    = 6162, // CG_PROFILE_MACRO(DX9Pixel20,ps_2_0,PS_2_0,"ps_2_0",6162,0)
    cgDX9Pixel2xProfile    = 6163, // CG_PROFILE_MACRO(DX9Pixel2x,ps_2_x,PS_2_X,"ps_2_x",6163,0)

    cgNProfiles
  {$ENDIF}
  );
{$ELSE}
const
  cgProfileStart = 6144;
  {$EXTERNALSYM cgProfileStart}

  CG_PROFILE_UNKNOWN = 6145;
  {$EXTERNALSYM CG_PROFILE_UNKNOWN}
  cgUnknownProfile = CG_PROFILE_UNKNOWN;
  {$EXTERNALSYM cgUnknownProfile}

  //# define CG_PROFILE_MACRO(name, compiler_id, compiler_id_caps, compiler_opt,int_id,vertex_profile) \
  //   cg##name##Profile = int_id,

  cgVertexProfile        = 6146; // CG_PROFILE_MACRO(Vertex,vp20,VP20,"vp20",6146,1)
  {$EXTERNALSYM cgVertexProfile}
  cgFragment20Profile    = 6147; // CG_PROFILE_MACRO(Fragment20,fp20,FP20,"fp20",6147,0)
  {$EXTERNALSYM cgFragment20Profile}
  cgVertex30Profile      = 6148; // CG_PROFILE_MACRO(Vertex30,vp30,VP30,"vp30",6148,1)
  {$EXTERNALSYM cgVertex30Profile}
  cgFragmentProfile      = 6149; // CG_PROFILE_MACRO(Fragment,fp30,FP30,"fp30",6149,0)
  {$EXTERNALSYM cgFragmentProfile}
  cgARBVertexProfile     = 6150; // CG_PROFILE_MACRO(ARBVertex,arbvp1,ARBVP1,"arbvp1",6150,1)
  {$EXTERNALSYM cgARBVertexProfile}
  cgARBFragmentProfile   = 7000; // CG_PROFILE_MACRO(ARBFragment,arbfp1,ARBFP1,"arbfp1",7000,0)
  {$EXTERNALSYM cgARBFragmentProfile}

  cgDX9Vertex11Profile   = 6153; // CG_PROFILE_MACRO(DX9Vertex11,vs_1_1,VS_1_1,"vs_1_1",6153,1)
  {$EXTERNALSYM cgDX9Vertex11Profile}
  cgDX9Vertex20Profile   = 6154; // CG_PROFILE_MACRO(DX9Vertex20,vs_2_0,VS_2_0,"vs_2_0",6154,1)
  {$EXTERNALSYM cgDX9Vertex20Profile}
  cgDX9Vertex2xProfile   = 6155; // CG_PROFILE_MACRO(DX9Vertex2x,vs_2_x,VS_2_X,"vs_2_x",6155,1)
  {$EXTERNALSYM cgDX9Vertex2xProfile}

  cgDX9Pixel11Profile    = 6159; // CG_PROFILE_MACRO(DX9Pixel11,ps_1_1,PS_1_1,"ps_1_1",6159,0)
  {$EXTERNALSYM cgDX9Pixel11Profile}
  cgDX9Pixel12Profile    = 6160; // CG_PROFILE_MACRO(DX9Pixel12,ps_1_2,PS_1_2,"ps_1_2",6160,0)
  {$EXTERNALSYM cgDX9Pixel12Profile}
  cgDX9Pixel13Profile    = 6161; // CG_PROFILE_MACRO(DX9Pixel13,ps_1_3,PS_1_3,"ps_1_3",6161,0)
  {$EXTERNALSYM cgDX9Pixel13Profile}
  cgDX9Pixel20Profile    = 6162; // CG_PROFILE_MACRO(DX9Pixel20,ps_2_0,PS_2_0,"ps_2_0",6162,0)
  {$EXTERNALSYM cgDX9Pixel20Profile}
  cgDX9Pixel2xProfile    = 6163; // CG_PROFILE_MACRO(DX9Pixel2x,ps_2_x,PS_2_X,"ps_2_x",6163,0)
  {$EXTERNALSYM cgDX9Pixel2xProfile}

  cgNProfiles            = 6164;
  {$EXTERNALSYM cgNProfiles}

type
  TcgProfileType = DWORD;
{$ENDIF}
  cgProfileType = TcgProfileType;
  {$NODEFINE cgProfileType}
  {$NODEFINE TcgProfileType}
  {$HPPEMIT 'typedef cgProfileType TcgProfileType;'}



(*************************************************************************)
(*** Function Prototypes                                               ***)
(*************************************************************************)


(*******************************************************************)
(*** cg Misc Functions                                         ****)
(*******************************************************************)

procedure cgCleanup; cdecl; external CgLibrary;
{$EXTERNALSYM cgCleanup}

(* This will probably be deprecated in future releases *)
procedure cgSetCompilerExe(const exe: PChar); cdecl; external CgLibrary;
{$EXTERNALSYM cgSetCompilerExe}

// extern const char *cgErrorMsg(cgError error);
function cgErrorMsg(error: TcgError): PChar { const }; cdecl; external CgLibrary;
{$EXTERNALSYM cgErrorMsg}

(*******************************************************************)
(*** cgContext Functions                                       ****)
(*******************************************************************)

function cgCreateContext: PcgContext; cdecl; external CgLibrary name 'cgGL_DEPRECATEDAPI_CreateContext';
{$EXTERNALSYM cgCreateContext}

procedure cgFreeContext(context: PcgContext); cdecl; external CgLibrary;
{$EXTERNALSYM cgFreeContext}

function cgAddProgram(context: PcgContext; const text: PChar;
  profile: TcgProfileType; const entry: PChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddProgram}

function cgAddProgramFromFile(context: PcgContext; const filename: PChar;
  profile: TcgProfileType; const entry: PChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddProgramFromFile}

type
  PPCharArray = ^TPCharArray;
  TPCharArray = array[0..MaxInt div SizeOf(PChar) - 1] of PChar;
  PPChar = ^PChar; //Clootie: It's actually pointer to array of PChar strings

function cgAddProgramArgs(context: PcgContext; const text: PChar;
  profile: TcgProfileType; const entry: PChar;
  nargs: Integer; const args: PPChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddProgramArgs}

function cgAddProgramFromFileArgs(context: PcgContext; const filename: PChar;
  profile: TcgProfileType; const entry: PChar;
  nargs: Integer; const args: PPChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddProgramFromFileArgs}

function cgAddPrecompiledProgram(context: PcgContext; const text: PChar;
  profile: TcgProfileType; const entry: PChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddPrecompiledProgram}

function cgAddPrecompiledProgramFromFile(context: PcgContext; const filename: PChar;
  profile: TcgProfileType; const entry: PChar): TcgError; cdecl; external CgLibrary;
{$EXTERNALSYM cgAddPrecompiledProgramFromFile}

function cgGetLastListing(context: PcgContext): PChar { const }; cdecl; external CgLibrary name 'cgGL_DEPRECATEDAPI_GetLastListing';
{$EXTERNALSYM cgGetLastListing}

(*******************************************************************)
(*** cgProgram Functions                                        ***)
(*******************************************************************)

function cgGetNextProgram(context: PcgContext; iter: PcgProgramIter): PcgProgramIter; cdecl; external CgLibrary name 'cgGL_DEPRECATEDAPI_GetNextProgram';
{$EXTERNALSYM cgGetNextProgram}

function cgProgramByName(context: PcgContext; const name: PChar): PcgProgramIter; cdecl; external CgLibrary;
{$EXTERNALSYM cgProgramByName}

function cgGetLastProgram(context: PcgContext): PcgProgramIter; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetLastProgram}

procedure cgFreeProgramIter(program_: PcgProgramIter); cdecl; external CgLibrary;
{$EXTERNALSYM cgFreeProgramIter}

function cgGetProgramName(const program_: PcgProgramIter): PChar { const }; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetProgramName}

function cgGetProgramProfile(const program_: PcgProgramIter): TcgProfileType; cdecl; external CgLibrary name 'cgGL_DEPRECATEDAPI_ProgramProfile';
{$EXTERNALSYM cgGetProgramProfile}

function cgGetProgramObjectCode(const program_: PcgProgramIter): PChar { const }; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetProgramObjectCode}



(*******************************************************************)
(*** Parameter and Binding Functions                            ****)
(*******************************************************************)

function cgGetNextBind(program_: PcgProgramIter; iter: PcgBindIter): PcgBindIter; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetNextBind}

function cgGetBindByName(program_: PcgProgramIter; const parameter_name: PChar): PcgBindIter; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindByName}

function cgDuplicateBindIter(bind: PcgBindIter): PcgBindIter; cdecl; external CgLibrary;
{$EXTERNALSYM cgDuplicateBindIter}

procedure cgFreeBindIter(iter: PcgBindIter); cdecl; external CgLibrary;
{$EXTERNALSYM cgFreeBindIter}

function cgGetBindParamName(const bind: PcgBindIter): PChar { const }; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindParamName}

function cgGetBindParamType(const bind: PcgBindIter): TcgParamType; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindParamType}

function cgGetBindLocation(const bind: PcgBindIter): TcgBindLocation; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindLocation}

function cgGetBindAddress(const bind: PcgBindIter): Longword; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindAddress}

function cgGetBindValueType(const bind: PcgBindIter; out array_size: Integer): TcgValueType; cdecl; external CgLibrary;
{$EXTERNALSYM cgGetBindValueType}

